import { customElement } from "@refinitiv-ui/core/decorators/custom-element.js";
import { JSXInterface } from "../../tr-grid-util/es6/jsx";
import {
	BasicElement,
	html
} from "@refinitiv-ui/core";
import "@refinitiv-ui/elements/button";
import "@refinitiv-ui/elements/checkbox";
import "@refinitiv-ui/elements/collapse";
import "@refinitiv-ui/elements/dialog";
import "@refinitiv-ui/elements/icon";
import "@refinitiv-ui/elements/text-field";
import "@refinitiv-ui/elements/number-field";
import "@refinitiv-ui/elements/list";
import "@refinitiv-ui/elements/radio-button";
import "@refinitiv-ui/elements/select";
import "@refinitiv-ui/elements/button-bar";
import "@refinitiv-ui/elements/tooltip";
import "@refinitiv-ui/elements/item";
import "@refinitiv-ui/elements/color-dialog";
import ElfUtil from "../../tr-grid-util/es6/ElfUtil.js";
import { DATE_TIME, toDateTimeType } from "../../tr-grid-util/es6/FieldFormatter.js";
import ExpressionParser from "../../tr-grid-util/es6/ExpressionParser.js";
import translation from "./locale/translation.js";
import { PercentBar } from "../../tr-grid-util/es6/PercentBar.js";
import ElementObserver from "../../tr-grid-util/es6/ElementObserver.js";
import { PreviewTable } from "./preview-table.js";

declare namespace ColumnFormatDialog {

    type SupportDisplayStyleOptions = {
        bar: boolean
    };

    type SupportValueFormatOptions = {
        fx: boolean
    };

    type Config = {
        data: any,
        supportHighlightApplyToSwitch?: boolean|null,
        supportValueFormatOptions?: ColumnFormatDialog.SupportValueFormatOptions|null,
        supportDisplayStyleOptions?: ColumnFormatDialog.SupportDisplayStyleOptions|null,
        fields?: (string)[]|null,
        confirm?: ((...params: any[]) => any)|null,
        cancel?: ((...params: any[]) => any)|null
    };

}

declare class ColumnFormatDialog extends BasicElement {

    constructor();

    public init(userConfig?: ColumnFormatDialog.Config|null): void;

    public show(): void;

    public hide(): void;

    public updateDataWithAutosuggest(selectedItem: any, autoSuggest: any): void;

}

declare global {
	interface HTMLElementTagNameMap {
		"column-format-dialog": ColumnFormatDialog;
	}
	namespace JSX {
		interface IntrinsicElements {
			"column-format-dialog": ColumnFormatDialog | JSXInterface.HTMLAttributes;
		}
	}
}

export { ColumnFormatDialog };
export default ColumnFormatDialog;