import { customElement } from "@refinitiv-ui/core/decorators/custom-element.js";
import { JSXInterface } from "../../tr-grid-util/es6/jsx";
import { BasicElement, html } from "@refinitiv-ui/core";
import "@refinitiv-ui/elements/button";
import { TreeRenderer as DefaultRenderer } from "@refinitiv-ui/elements/tree";
import "@refinitiv-ui/elements/dialog";
import "@refinitiv-ui/elements/search-field";
import "@refinitiv-ui/elements/pill";
import "@refinitiv-ui/elements/item";
import translation from "./locale/translation.js";
import ElementObserver from "../../tr-grid-util/es6/ElementObserver.js";
import { ElfUtil } from "../../tr-grid-util/es6/ElfUtil.js";
import { isEmptyObject } from "../../tr-grid-util/es6/Util.js";

declare namespace ColumnSelectionDialog {

    type Config = {
        data: (any)[]|null,
        visibleItems?: (any)[]|null,
        defaultItems?: (any)[]|null,
        confirm?: ((...params: any[]) => any)|null,
        cancel?: ((...params: any[]) => any)|null,
        excludedColumns?: number|null,
        excludedLeftColumns?: number|null,
        excludedRightColumns?: number|null,
        unmovableColumns?: number|null,
        descriptionBox?: boolean|null,
        middleSeparator?: string|null,
        collapseAll?: boolean|null,
        width?: number|null,
        height?: number|null,
        tags?: (string)[]|null,
        infoTooltip?: string|null,
        searchPlaceholder?: string|null,
        dialogLabel?: string|null,
        availableItemsLabel?: string|null,
        visibleItemsLabel?: string|null
    };

}

declare class ColumnSelectionDialog extends BasicElement {

    constructor();

    public init(options?: ColumnSelectionDialog.Config|null): void;

    public show(): void;

    public hide(): void;

}

declare global {
	interface HTMLElementTagNameMap {
		"column-selection-dialog": ColumnSelectionDialog;
	}
	namespace JSX {
		interface IntrinsicElements {
			"column-selection-dialog": ColumnSelectionDialog | JSXInterface.HTMLAttributes;
		}
	}
}

export { ColumnSelectionDialog };
export default ColumnSelectionDialog;