import CellSpan from "./CellSpan.js";

declare class CellSpans {

    constructor();

    public removeColumn(at: number): boolean;

    public freezeMapping(bool?: boolean|null): void;

    public shiftColumn(from: number, amount: number): boolean;

    public removeSpan(indexX: number, indexY: number): CellSpan|null;

    public removeSpanByColIndex(at: number, opt_ary?: (CellSpan)[]|null): (CellSpan)[]|null;

    public removeSpanStartedFromRowIndex(at: number, opt_ary?: (CellSpan)[]|null): (CellSpan)[]|null;

    public clearAllSpans(): (CellSpan)[]|null;

    public hasSpan(): boolean;

    public getSpan(indexX: number, indexY: number): CellSpan|null|null;

    public getOccupyingSpan(indexX: number, indexY: number): CellSpan|null|null;

    public getAllSpans(): (CellSpan)[];

    public getColSpan(indexX: number, indexY: number): number;

    public getRowSpan(indexX: number, indexY: number): number;

    public setColSpan(indexX: number, indexY: number, spanVal: number): CellSpan|null;

    public setRowSpan(indexX: number, indexY: number, spanVal: number): CellSpan|null;

}

export default CellSpans;
export { CellSpans };
