import Ext from "../../../../tr-grid-util/es6/Ext.js";
import EventDispatcher from "../event/EventDispatcher.js";
import EventListeners from "../event/EventListeners.js";
import Util from "../util/util.js";

declare class ElementWrapper extends EventDispatcher {

    constructor(opt_element?: Element|null);

    public getContent(opt_allContent?: boolean|null): Element|Node|NodeList|null;

    public setContent(content: string|Element|ElementWrapper|any, opt_tooltip?: string|null): Element|null;

    public addContent(content: Element|Node|ElementWrapper|null): Element|null;

    public removeContent(content: Element|Node|ElementWrapper|null): boolean;

    public listen(type: string, handler: ((...params: any[]) => any)|null, opt_priority?: number|null): void;

    public unlisten(type: string, handler: ((...params: any[]) => any)|null): void;

    public unlistenAll(opt_type?: string|null): void;

    public dispose(): void;

    public getElement(): Element|null;

    public getNextSibling(): Element|Node|null;

    public getParent(): Element|Node|null;

    public setParent(parent: ElementWrapper|Element|Node|null, opt_prepend?: boolean|null): void;

    public insertBefore(nextSibling: ElementWrapper|Element|Node|null): void;

    public insertAfter(previousSibling: ElementWrapper|Element|Node|null): void;

    public hasClass(str: string): boolean;

    public addClass(str: string): void;

    public removeClass(str: string): void;

    public toggleClass(cls: string, forcedVal?: (boolean|null)|null): void;

    public enableClass(str: string, opt_enabled?: boolean|null): void;

    public getClass(): string;

    public setClass(str: string): void;

    public getAttribute(str: string): string;

    public hasAttribute(str: string): boolean;

    public setAttribute(str: string, val: string): void;

    public setAttributes(json: any): void;

    public removeAttribute(str: string): void;

    public getStyle(str: string): string;

    public setStyle(str: string, val: string): void;

    public setStyles(json: any): void;

    public getId(): string;

    public setId(val: string): void;

    public toString(): string;

    public getTextContent(): string;

    public setTextContent(str: string): void;

    public getLeft(): number;

    public setLeft(val: number): boolean;

    public getTop(): number;

    public setTop(val: number): boolean;

    public getWidth(): number;

    public setWidth(val: number): boolean;

    public getHeight(): number;

    public setHeight(val: number): boolean;

    public getBoundingClientRect(): any;

    public fillParentWidth(opt_percent?: number|null): boolean;

    public fillParentHeight(opt_percent?: number|null): boolean;

    public getTooltip(): string;

    public setTooltip(str: string): void;

    public show(opt_shown?: boolean|null): void;

    public hide(opt_hidden?: boolean|null): void;

    public isVisible(): boolean;

    public enable(opt_enabled?: boolean|null): void;

    public disable(opt_disabled?: boolean|null): void;

    public isEnabled(): boolean;

    public getScrollLeft(): number;

    public getScrollTop(): number;

    public isEndOfHorizontalScroll(): boolean;

    public isEndOfVerticalScroll(): boolean;

}

export default ElementWrapper;
export { ElementWrapper };
