import Util from "../util/util.js";

/** @constructor
* @ignore
*/
let VirtualItems = function () {
	this._items = [];
};
/** @type {Array.<!Object>}
* @private
*/
VirtualItems.prototype._items = null;

/** @public
*/
VirtualItems.prototype.dispose = function () {
	this._items = null;
};

/** @public
* @ignore
* @param {number} count
*/
VirtualItems.prototype.setItemCount = function (count) {
	let ary = this._items;
	let len = ary.length;
	if(len !== count) {
		ary.length = count;
		while(len < count) {
			ary[len++] = {};
		}
	}
};
/** @public
* @ignore
* @param {number} idx
* @return {Object}
*/
VirtualItems.prototype.getItem = function (idx) {
	return this._items[idx] || null;
};
/** @public
* @ignore
* @param {number} numItems Index of the first item to be moved to the top
*/
VirtualItems.prototype.moveItemsToTop = function (numItems) {
	this._items = Util.cycleArray(this._items, numItems);
};

export default VirtualItems;
export { VirtualItems };
