import Ext from "../../../../tr-grid-util/es6/Ext.js";
import Util from "../util/util.js";
import EventDispatcher from "../event/EventDispatcher.js";
import ILayoutGrid from "../ILayoutGrid.js";
import LayoutGrid from "../LayoutGrid.js";
import DataTable from "../../data/DataTable.js";
import DataView from "../../data/DataView.js";
import Conflator from "../util/Conflator.js";

declare class SectionSettings extends EventDispatcher {

    constructor(grid: ILayoutGrid);

    public getId(): string;

    public setId(str?: string|null): string;

    public getSection(): ILayoutGrid|null;

    public getSectionName(): string;

    public getIndex(): number;

    public getType(): string;

    public setType(type: string): void;

    public getDataSource(): DataView|null;

    public setDataSource(dataView: DataView|null): void;

    public getRootDataSource(): DataTable|DataView|null;

    public getData(colName: string, rowRef: number|string|null): any;

    public setData(colName: string, rowRef: number|string|null, data: any): boolean;

    public getRowData(rowRef: number|string|null): { [key: string]:  any };

    public removeRowData(rowRef: number|string|null): boolean;

    public activateColumns(activations: (boolean|undefined)[]|null, firstIndex: number, lastIndex: number): void;

    public getChildren(): (SectionSettings)[]|null;

    public getParent(): SectionSettings|null;

    public getDataChangedConflator(): Conflator;

    public disableConflation(opt_disabled: boolean): void;

    public disableDataBinding(opt_disabled?: boolean|null): void;

    public getAutoSyncRowCount(): boolean;

    public setAutoSyncRowCount(bool: boolean): void;

    public extendEventArg(e?: any): any;

    public extendRenderEventArg(e: any, fromR: number, toR: number): any;

    public extendDataEventArg(e?: any, begin?: number|null, end?: number|null): any;

    public enableColumnVirtualization(opt_enabled?: boolean|null): void;

    public isBinding(): boolean;

    public updateRowData(fromRowIndex?: number|null, lastRowIndex?: number|null, e?: any): void;

    public rerender(): void;

    public snapshot(clone: ILayoutGrid|null): void;

}

declare function rowIndex(activations: (boolean|undefined)[]|null, firstIndex: number, lastIndex: number): void;

export default SectionSettings;
export { SectionSettings };
