

declare class SelectionList {

    constructor();

    public clone(): SelectionList;

    public toString(): string;

    public select(at: number): boolean;

    public deselect(at: number): boolean;

    public deselectFrom(at: number): boolean;

    public toggleSelection(at: number): void;

    public singularlySelect(at: number): boolean;

    public selectRange(anchor: number, length: number): void;

    public deselectRange(at: number, length: number): void;

    public hasSelection(at: number, length: number): boolean;

    public getSelection(at: number): boolean;

    public setSelection(at: number, opt_selected?: boolean|null): boolean;

    public getSelectionAnchor(): number;

    public setSelectionAnchor(at: number): void;

    public getSelectionCount(): number;

    public getFirstSelectedIndex(): number;

    public getLastSelectedIndex(): number;

    public getAllSelections(): (number)[];

    public getConnectedRanges(from?: number|null, to?: number|null): (number)[][];

    public getSelectionMap(): (boolean)[]|null;

    public clearAllSelections(): number;

    public copyFrom(srcSelections: SelectionList|null, fromSrcIndex: number, offset: number, forLength: number): void;

}

export default SelectionList;
export { SelectionList };
