import Util from "./grid/util/util.js";

// Core
import EventDispatcher from "./grid/event/EventDispatcher.js";
import ElementWrapper from "./grid/components/ElementWrapper.js";
import ILayoutGrid from "./grid/ILayoutGrid.js";
import LayoutGrid from "./grid/LayoutGrid.js";
import Core from "./grid/Core.js";

// Components
import CellFloatingPanel from "./grid/components/CellFloatingPanel.js";
import Cell from "./grid/components/Cell.js";
import CellSpan from "./grid/components/CellSpan.js";
import CellSpans from "./grid/components/CellSpans.js";
import Column from "./grid/components/Column.js";
import Scrollbar from "./grid/components/Scrollbar.js";
import HScrollbar from "./grid/components/HScrollbar.js";
import VScrollbar from "./grid/components/VScrollbar.js";
import VirtualizedLayoutGrid from "./grid/VirtualizedLayoutGrid.js";

// Util
import Conflator from "./grid/util/Conflator.js";
import Reverter from "./grid/util/Reverter.js";

import TrackLayout from "./grid/util/TrackLayout.js";
import Virtualizer from "./grid/util/Virtualizer.js";
import SelectionList from "./grid/util/SelectionList.js";
import SectionSettings from "./grid/util/SectionSettings.js";

// Plugins
import SortableTitlePlugin from "./grid/plugins/SortableTitlePlugin.js";

// Data
import ColumnStats from "./data/ColumnStats.js";
import DataCache from "./data/DataCache.js";
import DataTable from "./data/DataTable.js";
import DataView from "./data/DataView.js";
import SegmentCollection from "./data/SegmentCollection.js";

// tsd-disable
var tr = window["tr"];
if(!tr) {
	tr = window["tr"] = {};
}
var grid = tr["grid"];
if(!grid) {
	grid = tr["grid"] = {};
}

Object.assign(tr, Util);
tr.EventDispatcher = EventDispatcher;
tr.ElementWrapper = ElementWrapper;
tr.ILayoutGrid = ILayoutGrid;
tr.LayoutGrid = LayoutGrid;
tr.Grid = Core;

// Data
tr.ColumnStats = ColumnStats;
tr.DataCache = DataCache;
tr.DataTable = DataTable;
tr.DataView = DataView;
tr.SegmentCollection = SegmentCollection;

// Components
grid.CellFloatingPanel = CellFloatingPanel;
grid.Cell = Cell;
grid.CellSpan = CellSpan;
grid.CellSpans = CellSpans;
grid.Column = Column;
grid.Scrollbar = Scrollbar;
grid.HScrollbar = HScrollbar;
grid.VScrollbar = VScrollbar;
grid.VirtualizedLayoutGrid = VirtualizedLayoutGrid;

// Util
grid.Conflator = Conflator;
grid.Reverter = Reverter;

grid.TrackLayout = TrackLayout;
grid.Virtualizer = Virtualizer;
grid.SelectionList = SelectionList;
grid.SectionSettings = SectionSettings;

// Plugins
grid.SortableTitlePlugin = SortableTitlePlugin;
// tsd-enable

export {
	// Core
	EventDispatcher,
	ElementWrapper,
	ILayoutGrid,
	LayoutGrid,
	Core,

	// Data
	ColumnStats,
	DataCache,
	DataTable,
	DataView,

	// Components
	CellFloatingPanel,
	Cell,
	CellSpan,
	CellSpans,
	Column,
	Scrollbar,
	HScrollbar,
	VScrollbar,
	VirtualizedLayoutGrid,

	// Util
	Conflator,
	Reverter,

	TrackLayout,
	Virtualizer,
	SelectionList,
	SectionSettings,

	// Plugins
	SortableTitlePlugin
};
export default Core;
