import { customElement } from "@refinitiv-ui/core/decorators/custom-element.js";
import { JSXInterface } from "../../tr-grid-util/es6/jsx";
import { BasicElement, html } from "@refinitiv-ui/core";
import "@refinitiv-ui/elements/button";
import "@refinitiv-ui/elements/item";
import "@refinitiv-ui/elements/checkbox";
import translation from "./locale/translation.js";

declare namespace CheckboxList {

    type itemState = {
        type?: string|null,
        label?: string|null,
        checked?: boolean|null,
        index?: number|null,
        elem?: Element|null,
        value?: (string|boolean)|null
    };

}

declare class CheckboxList extends BasicElement {

    constructor();

    public setData(list: (any)[]|null): void;

    public updateData(list?: (any)[]|null): void;

    public getSelectedItems(): (object)[];

    public selectAll(selected?: boolean|null): void;

    public deselectAll(): void;

    public filter(inputFilter?: (string|((...params: any[]) => any))|null): void;

}

declare global {
	interface HTMLElementTagNameMap {
		"checkbox-list": CheckboxList;
	}
	namespace JSX {
		interface IntrinsicElements {
			"checkbox-list": CheckboxList | JSXInterface.HTMLAttributes;
		}
	}
}

export { CheckboxList };
export default CheckboxList;