import { customElement } from "@refinitiv-ui/core/decorators/custom-element.js";
import { JSXInterface } from "../../tr-grid-util/es6/jsx";
import { BasicElement, html } from "@refinitiv-ui/core";
import "@refinitiv-ui/elements/button";
import "@refinitiv-ui/elements/checkbox";
import "@refinitiv-ui/elements/combo-box";
import "@refinitiv-ui/elements/item";
import "@refinitiv-ui/elements/panel";
import "@refinitiv-ui/elements/radio-button";
import "@refinitiv-ui/elements/button-bar";
import "@refinitiv-ui/elements/search-field";
import "@refinitiv-ui/elements/datetime-picker";

import {Dom} from "../../tr-grid-util/es6/Dom.js";
import Popup from "../../tr-grid-util/es6/Popup.js";
import DateTime from "../../tr-grid-util/es6/DateTime.js";
import { DATE_TIME, toDateTimeType } from "../../tr-grid-util/es6/FieldFormatter.js";
import ElementObserver from "../../tr-grid-util/es6/ElementObserver.js";
import { ElfUtil } from "../../tr-grid-util/es6/ElfUtil.js";
import translation from "./locale/translation.js";
import "./checkbox-list.js";

declare namespace FilterDialog {

    type Config = {
        data: any,
        sortState?: string|null,
        sortUI?: boolean|null,
        filterUI?: boolean|null,
        advancedFilter?: boolean|null,
        compactMode?: boolean|null,
        dateTimeFormat?: string|null,
        blankValues?: (string|boolean)|null,
        filterChanged?: ((...params: any[]) => any)|null,
        confirm?: ((...params: any[]) => any)|null,
        cancel?: ((...params: any[]) => any)|null,
        sortChanged?: ((...params: any[]) => any)|null
    };

    type ComboBoxItem = {
        label: string,
        value: string
    };

}

declare class FilterDialog extends BasicElement {

    constructor();

    public init(options: FilterDialog.Config|null): void;

    public show(): void;

    public hide(): void;

    public setSortState(val: string): void;

    public hideSortUI(val: boolean): void;

}

declare global {
	interface HTMLElementTagNameMap {
		"filter-dialog": FilterDialog;
	}
	namespace JSX {
		interface IntrinsicElements {
			"filter-dialog": FilterDialog | JSXInterface.HTMLAttributes;
		}
	}
}

export { FilterDialog };
export default FilterDialog;