import FormatterBuilder from "./FormatterBuilder.js";

/** @private
* @function
* @param {Element} element
* @param {Object} ctx
*/
let onElementUpdated = function (element, ctx) {
	element.checked = ctx.value;
	if (ctx.labelField) {
		let text = ctx.getData(ctx.labelField);
		element.textContent = (text != null) ?  text : '';
	}
};

/** To bound data and view of the current checkbox state
* @private
* @param {*} e
* @param {*} ctx
*/
let _changeHandler = function (e, ctx) {
	ctx.value = e.detail.value;
	ctx.setData(ctx.field, ctx.value);
};

/** @constructor
* @param {*=} options
*/
let CoralCheckboxFormatter = function (options) {

};

/** @public
* @param {(FormatterBuilder.Options|Object)=} options
* @return {Object}
*/
CoralCheckboxFormatter.create = function (options) {
	let defaultOpt = {
		tagName: "ef-checkbox",
		refName: "CoralCheckboxFormatter",
		onElementUpdated: onElementUpdated,
		changeHook: "checked-changed",
		changeHandler: _changeHandler
	};

	return FormatterBuilder.create(options, defaultOpt);
};

export default CoralCheckboxFormatter;
export { CoralCheckboxFormatter };
