import FormatterBuilder from "./FormatterBuilder.js";

/** @typedef {Object} EFButtonFormatter~Options
* @description FormatterBuilder options
* @property {string=} label
*/

/** @private
* @function
* @param {Element} element
* @param {Object} ctx
*/
let onElementUpdated = function (element, ctx) {
	let label = (typeof ctx.label === "string") ? ctx.label : ctx.value;
	element.textContent = label;
};

/** @constructor
* @param {*=} options
*/
let EFButtonFormatter = function (options) {

};

/** @public
* @param {(FormatterBuilder.Options|EFButtonFormatter.Options|Object)=} options
* @return {Object}
*/
EFButtonFormatter.create = function (options) {
	let defaultOpt = {
		tagName: "ef-button",
		refName: "EFButtonFormatter",
		styles: {
			maxWidth: "100%",
			margin: "0"
		},
		onElementUpdated: onElementUpdated,
		label: null // use ctx.value by default
	};

	return FormatterBuilder.create(options, defaultOpt);
};

export default EFButtonFormatter;
export { EFButtonFormatter };
