import FormatterBuilder from "./FormatterBuilder.js";

/** @private
* @function
* @param {Element} element
* @param {Object} ctx
*/
let onElementUpdated = function (element, ctx) {
	element.value = ctx.value;
};

let _changeHandler = function (e, ctx) {
	ctx.value = e.detail.value;
	ctx.setData(ctx.field, ctx.value);
};

/** @constructor
* @param {*=} options
*/
let EFNumberFieldFormatter = function (options) {

};

/** @public
* @param {(FormatterBuilder.Options|Object)=} options
* @return {Object}
*/
EFNumberFieldFormatter.create = function (options) {
	let defaultOpt = {
		tagName: "ef-number-field",
		refName: "EFNumberFieldFormatter",
		onElementUpdated: onElementUpdated,
		changeHook: "value-changed",
		changeHandler: _changeHandler,
		styles: {
			margin: "0",
			width: "100%"
		}
	};

	return FormatterBuilder.create(options, defaultOpt);
};

export default EFNumberFieldFormatter;
export { EFNumberFieldFormatter };
