import FormatterBuilder from "./FormatterBuilder.js";

let onElementUpdated = function (element, ctx) {
	element.value = ctx.value;
};

let _changeHandler = function (e, ctx) {
	ctx.value = e.detail.value;
	ctx.setData(ctx.field, ctx.value);
};

/** @constructor
* @param {*=} options
*/
let EFTextFieldFormatter = function (options) {

};

/** @public
* @param {(FormatterBuilder.Options|Object)=} options
* @return {Object}
*/
EFTextFieldFormatter.create = function (options) {
	let defaultOpt = {
		tagName: "ef-text-field",
		refName: "EFTextFieldFormatter",
		onElementUpdated: onElementUpdated,
		changeHook: "value-changed",
		changeHandler: _changeHandler,
		styles: {
			margin: "0",
			width: "100%"
		}
	};

	return FormatterBuilder.create(options, defaultOpt);
};

export default EFTextFieldFormatter;
export { EFTextFieldFormatter };
