import FormatterBuilder from "./FormatterBuilder.js";

/** @private
* @function
* @param {Element} element
* @param {Object} ctx
*/
let onElementUpdated = function (element, ctx) {
	element.checked = ctx.value;
};

/** To bound data and view of the current ef-toggle state
* @private
* @function
* @param {*} e
* @param {*} ctx
*/
let _changeHandler = function (e, ctx) {
	ctx.value = e.detail.value;
	ctx.setData(ctx.field, ctx.value);
};

/** @constructor
* @param {*=} options
*/
let EFToggleFormatter = function (options) {

};

/** @public
* @param {(FormatterBuilder.Options|Object)=} options
* @return {Object}
*/
EFToggleFormatter.create = function (options) {
	let defaultOpt = {
		tagName: "ef-toggle",
		refName: "EFToggleFormatter",
		onElementUpdated: onElementUpdated,
		changeHook: "checked-changed",
		changeHandler: _changeHandler
	};

	return FormatterBuilder.create(options, defaultOpt);
};

export default EFToggleFormatter;
export { EFToggleFormatter };
