import FormatterBuilder from "./FormatterBuilder.js";

let onElementUpdated = function (element, ctx) {
	element.value = ctx.value;
};

let _changeHandler = function (e, ctx) {
	ctx.value = e.currentTarget.value;
	ctx.setData(ctx.field, ctx.value);
};

/** @constructor
* @param {*=} options
*/
let SimpleInputFormatter = function (options) {

};

/** @public
* @param {(FormatterBuilder.Options|Object)=} options
* @return {Object}
*/
SimpleInputFormatter.create = function (options) {
	let defaultOpt = {
		tagName: "input",
		refName: "SimpleInputFormatter",
		onElementUpdated: onElementUpdated,
		changeHook: "change",
		changeHandler: _changeHandler,
		styles: {
			margin: "0",
			width: "100%"
		}
	};

	return FormatterBuilder.create(options, defaultOpt);
};

export default SimpleInputFormatter;
export { SimpleInputFormatter };
