import FormatterBuilder from "./FormatterBuilder.js";


let onElementUpdated = function (element, ctx) {
	element.textContent = ctx.value;
};

let onElementCreated = function (element, ctx) {
	element.classList.add("text");
};

/** @constructor
* @param {*=} options
*/
let TextFormatter = function (options) {

};

/** @public
* @param {(FormatterBuilder.Options|Object)=} options
* @return {Object}
*/
TextFormatter.create = function (options) {
	let defaultOpt = {
		tagName: "div",
		refName: "TextFormatter",
		onElementUpdated: onElementUpdated,
		onElementCreated: onElementCreated
	};

	return FormatterBuilder.create(options, defaultOpt);
};

export default TextFormatter;
export { TextFormatter };
