import { JSXInterface } from "../../tr-grid-util/es6/jsx";
import {
	ResponsiveElement,
	css,
	unsafeCSS,
	html
} from "@refinitiv-ui/core";
import { customElement } from "@refinitiv-ui/core/decorators/custom-element.js";
import RowDefinition from "../../rt-grid/es6/RowDefinition.js";
import ColumnDefinition from "../../rt-grid/es6/ColumnDefinition.js";
import ElfUtil from "../../tr-grid-util/es6/ElfUtil.js";
import { Grid as RealtimeGrid } from "../../rt-grid/es6/Grid.js";
import ConditionalColoringPlugin from "../../tr-grid-conditional-coloring/es6/ConditionalColoring.js";
import RowSegmentingPlugin from "../../row-segmenting/es6/RowSegmenting.js";
import ColumnDraggingPlugin from "../../column-dragging/es6/ColumnDragging.js";
import cssStr from "../../core/es6/tr-grid-theme.js";

declare namespace Grid {

    type Config = {
        config?: any,
        data?: any[]|null,
        columns?: any[]|null,
        rows?: any[]|null
    };

}

declare class Grid extends ResponsiveElement {

    constructor();

    config?: RealtimeGrid.GridOptions|null;
    data?: any[]|null;
    columns?: (ColumnDefinition.Options)[]|null;
    rows?: (RowDefinition.Options)[]|null;
    api?: RealtimeGrid|null;

}

declare global {
	interface HTMLElementTagNameMap {
		"efx-grid": Grid;
	}
	namespace JSX {
		interface IntrinsicElements {
			"efx-grid": Grid | JSXInterface.HTMLAttributes;
		}
	}
}

export default Grid;
export { Grid };