import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { EventDispatcher } from "../../tr-grid-util/es6/EventDispatcher.js";
import { Conflator } from "../../tr-grid-util/es6/Conflator.js";
import ReferenceCounter from "./ReferenceCounter.js";
import ColumnDefinition from "./ColumnDefinition.js";
import RowDefinition from "./RowDefinition.js"; // eslint-disable-line

declare class DataConnector extends EventDispatcher {

    constructor();

    public dispose(): void;

    public getAllRics(): (string)[]|null;

    public hasRic(): boolean;

    public getAllRowDefs(): (RowDefinition)[]|null;

    public getAllFields(): (string)[];

    public getRowDefByRic(ric: string): (RowDefinition)[]|null;

    public addRic(rowDef: RowDefinition|null): boolean;

    public removeRic(rowDef: RowDefinition|null, ric?: string|null): void;

    public removeAllRics(): void;

    public addFields(fieldRef: string|(string)[]|ColumnDefinition|null, referer?: string|null): void;

    public removeFields(fieldRef: ColumnDefinition|string|null, referer?: string|null): void;

    public removeFieldReferrer(referrer: string): void;

    public removeAllFields(): void;

    public reset(): void;

}

export { DataConnector };
export default DataConnector;
