/* eslint-disable */
import { injectCss, prettifyCss } from "../../tr-grid-util/es6/Util.js";
import { Core } from "../../core/es6/grid/Core.js";
/* eslint-enable */

/**
* @constructor
*/
let StyleLoader = {};

/** @public
 * @type {string}
 */
StyleLoader.chainIcon = '';

/** @type {string}
* @public
*/
StyleLoader.styles = prettifyCss([
	".tr-grid .chain-icon", [
		"cursor: pointer;"
	],
	".tr-grid .chain-icon .fallback-arrow", [
		"vertical-align: middle;",
		"font-size: 7px;",
		"line-height: 1;",
		"display: inline-block;", // For transformation
		"transform: scaleX(1.5);",
		"font-family: Arial;"
	],
	".tr-grid .closed .chain-icon", [
		"transform: translate(0px, -1px) rotate(-90deg);"
	]
]);

/** @public
* @param {Core} grid
*/
StyleLoader.applyStyle = function (grid) {
	if (grid && !grid._rowGroupingStyles) { // TODO: Support run-time theme loading
		grid._rowGroupingStyles = true; // Prevent loading the same style twice
		injectCss(StyleLoader.styles, grid.getElement());
	}
};

export { StyleLoader };
export default StyleLoader;
