import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { GridPlugin } from "../../tr-grid-util/es6/GridPlugin.js";

declare namespace StatisticsRowPlugin {

    type Options = {
        rows?: any[]|null,
        invalidText?: string|null,
        noColoring?: boolean|null,
        noFormatting?: boolean|null,
        useAllData?: boolean|null,
        postCalculation?: ((...params: any[]) => any)|null,
        postRendering?: ((...params: any[]) => any)|null
    };

    type ColumnOptions = {
        statistics?: (boolean|string)|null
    };

    type RowOptions = {
        placement?: string|null,
        statistic?: string|null,
        label?: string|null,
        id?: string|null
    };

    type RowReference = string|number|null;

    type Stats = {
        field?: string|null,
        label?: boolean|null,
        count?: number|null,
        sum?: number|null,
        average?: number|null,
        min?: number|null,
        max?: number|null
    };

}

declare class StatisticsRowPlugin extends GridPlugin {

    constructor(options?: StatisticsRowPlugin.Options|null);

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public setStatisticsRows(rows: (StatisticsRowPlugin.RowOptions)[]|null): void;

    public getStatisticsRows(): (StatisticsRowPlugin.RowOptions)[]|null;

    public setStatisticsRow(rowRef: StatisticsRowPlugin.RowReference|null, options: StatisticsRowPlugin.RowOptions|null): boolean;

    public addStatisticsRow(options: StatisticsRowPlugin.RowOptions|null): void;

    public removeStatisticsRow(rowRef: StatisticsRowPlugin.RowReference|null): void;

}

export default StatisticsRowPlugin;
export { StatisticsRowPlugin, StatisticsRowPlugin as StatisticsRow, StatisticsRowPlugin as StatisticsRowExtension };
