import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { GridPlugin } from "../../tr-grid-util/es6/GridPlugin.js";
import { Conflator } from "../../tr-grid-util/es6/Conflator.js";

declare namespace AutoTooltipPlugin {

    type Options = {
        header?: boolean|null,
        title?: boolean|null,
        footer?: boolean|null,
        content?: boolean|null,
        quickMode?: boolean|null
    };

    type ColumnOptions = {
        autoTooltip?: boolean|null
    };

}

declare class AutoTooltipPlugin extends GridPlugin {

    constructor(options?: AutoTooltipPlugin.Options|null);

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public applyTooltip(colIndex: number, fromR?: number|null, toR?: number|null): void;

    public applyTooltipToColumns(colIndices?: (number)[]|null): void;

    public applyTooltipToAllColumns(): void;

    public requestTooltipUpdate(): void;

}

export default AutoTooltipPlugin;
export { AutoTooltipPlugin, AutoTooltipPlugin as AutoTooltip, AutoTooltipPlugin as AutoTooltipExtension };
