import {Ext} from '../../tr-grid-util/es6/Ext.js';
import {GridPlugin} from '../../tr-grid-util/es6/GridPlugin.js';
import {ElfUtil} from '../../tr-grid-util/es6/ElfUtil.js';
import {injectCss, prettifyCss} from "../../tr-grid-util/es6/Util.js";

declare namespace CheckboxPlugin {

    type Options = {
        rowSelection?: boolean|null,
        field?: string|null,
        disablingField?: string|null,
        checkboxCreated?: ((...params: any[]) => any)|null,
        checkboxBinding?: ((...params: any[]) => any)|null,
        clicked?: ((...params: any[]) => any)|null,
        width?: number|null,
        topCheckboxHandler?: boolean|null
    };

    type ColumnOptions = {
        checkboxColumn?: boolean|null
    };

}

declare class CheckboxPlugin extends GridPlugin {

    constructor(options?: CheckboxPlugin.Options|null);

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public beforeProcessOption(optionName: string, optionVal: any): any;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public getCheckboxColumnIndex(): number;

    public getDisplayColumn(): number;

    public getCheckbox(sectionRef: any, rowIndex: number): Element|null;

    public selectAll(): void;

    public deselectAll(check: boolean): void;

    public selectCheckboxes(rowRefs: (number|string)[]|null, checked: boolean): void;

    public deselectCheckboxes(rowRefs: (number|string)[]|null, checked: boolean): void;

    public setCheckStates(rowRefs: (number|string)[]|null, checked: boolean): void;

    public checkAll(checked: boolean): void;

    public setAllCheckStates(checked: boolean): void;

    public selectAllPages(checked?: boolean|null): void;

    public disableCheckbox(rowRef: number|string|null, disabled: boolean): void;

    public enableCheckbox(rowRef: number|string|null): void;

    public getAllCheckedIndices(sectionRef: any, state?: string|null): (number)[];

    public getFilteredSelectedData(field?: string|null): any[];

    public getAllSelectedData(field?: string|null): any[];

    public getSelectedRowData(field?: string|null): any[];

}

declare function val(gridOptions?: any): any;

declare function newState(sectionRef: any, rowIndex: number, context?: any): void;

export default CheckboxPlugin;
export { CheckboxPlugin, CheckboxPlugin as Checkbox, CheckboxPlugin as CheckboxExtension };
