import {Ext} from '../../tr-grid-util/es6/Ext.js';
import {GridPlugin} from '../../tr-grid-util/es6/GridPlugin.js';
import {Dom} from '../../tr-grid-util/es6/Dom.js';
import { injectCss, prettifyCss } from "../../tr-grid-util/es6/Util.js";

declare namespace ColumnResizingPlugin {

    type Options = {
        preserveProportion?: boolean|null,
        preserveGridSize?: boolean|null,
        noResizing?: boolean|null,
        columnResized?: ((...params: any[]) => any)|null,
        dblClicked?: ((...params: any[]) => any)|null,
        dragStart?: ((...params: any[]) => any)|null,
        dragEnd?: ((...params: any[]) => any)|null
    };

    type ColumnOptions = {
        noResizing?: boolean|null,
        defaultWidth?: number|null
    };

}

declare class ColumnResizingPlugin extends GridPlugin {

    constructor(options?: ColumnResizingPlugin.Options|null);

    public getName(): string;

    public beforeProcessOption(optionName: string, optionVal: any): any;

    public hasMultiTableSupport(): boolean;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public disableResizing(colIndex: number, opt_disabled?: boolean|null): void;

    public getDraggedColumnIndex(): number;

    public getDraggedAnchorX(): number;

    public setColumnWidths(cols: (number)[]|null, width: (number)[]|number|null, opt_scalable?: boolean|null): void;

    public setAllColumnWidths(colWidth: number, scalability?: boolean|null): boolean;

    public getColumnWidths(): (number)[]|null;

    public resetAllColumnsToDefaultWidth(): boolean;

    public getColumnSizeStates(): (any)[]|null;

    public setColumnSizeStates(columns: (any)[]|string|null): void;

    public enablePipeHandleMode(bool?: boolean|null): void;

    public enableHandlebarMode(bool?: boolean|null): void;

}

export default ColumnResizingPlugin;
export { ColumnResizingPlugin, ColumnResizingPlugin as ColumnResizing, ColumnResizingPlugin as ColumnResizingExtension };
