import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { Dom } from "../../tr-grid-util/es6/Dom.js";
import { GridPlugin } from "../../tr-grid-util/es6/GridPlugin.js";
import { prettifyCss } from "../../tr-grid-util/es6/Util.js";

declare namespace ColumnSelectionPlugin {

    type Options = {
        singleSelection?: boolean|null,
        clickToggle?: boolean|null,
        selectionChanged?: ((...params: any[]) => any)|null,
        menuClicked?: ((...params: any[]) => any)|null,
        menuPosition?: string|null
    };

    type ColumnOptions = {
        unselectable?: boolean|null
    };

}

declare class ColumnSelectionPlugin extends GridPlugin {

    constructor(options?: ColumnSelectionPlugin.Options|null);

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public unload(host?: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public disable(opt_bool?: boolean|null): void;

    public isEnabled(): boolean;

    public hasSelectedColumn(): boolean;

    public getSelectedColumns(): (number)[];

    public getFirstSelectedColumn(): number;

    public getLastSelectedColumn(): number;

    public setSelectedColumn(colIndex: number, opt_select?: boolean|null, opt_grid?: any): boolean;

    public selectSingleColumn(opt_colIndex?: (number|null)|null, opt_grid?: any): void;

    public selectSingleGroup(groupId: string, opt_grid?: any): void;

    public selectRange(anchorIndex: number, len: number, opt_grid?: any): void;

    public selectAllColumns(): void;

    public clearAllSelections(): void;

    public clearSelectedColumns(): void;

    public clearSelection(cols?: (number|(number)[])|null): void;

    public selectAll(): void;

    public deselectAll(): void;

    public isSelectedColumn(colIndex: number): boolean;

    public getActiveGrid(): any;

    public dispatchSelectionChanged(): void;

}

export default ColumnSelectionPlugin;
export { ColumnSelectionPlugin, ColumnSelectionPlugin as ColumnSelection, ColumnSelectionPlugin as ColumnSelectionExtension };
