import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { GridPlugin } from "../../tr-grid-util/es6/GridPlugin.js";
import { ElfUtil } from "../../tr-grid-util/es6/ElfUtil.js";

declare namespace PaginationPlugin {

    type Options = {
        page?: number,
        pageSize?: number,
        element?: (string|Element),
        elements?: any[],
        pageChanged?: ((...params: any[]) => any)
    };

}

declare class PaginationPlugin {

    constructor(options?: any);

    public initialize(host: any, options: any): void;

    public unload(host: any): void;

    public setElement(elemRef?: any): void;

    public config(options?: any): void;

    public getConfigObject(out_obj?: any): any;

    public beforeProcessOption(optionName: string, options: any): any;

    public getTotalRows(): number;

    public getPageIndex(): number;

    public getPageCount(): number;

    public getPageSize(): number;

    public setPageSize(size: number): void;

    public setPage(page: number): void;

    public goto(pageIndex: number): void;

    public first(): void;

    public last(): void;

    public next(): void;

    public previous(): void;

}

export default PaginationPlugin;
export { PaginationPlugin, PaginationPlugin as Pagination, PaginationPlugin as PaginationExtension };
