import {Ext} from '../../tr-grid-util/es6/Ext.js';
import {GridPlugin, colDataGetter} from '../../tr-grid-util/es6/GridPlugin.js';
import {PercentBar} from '../../tr-grid-util/es6/PercentBar.js';
import {Dom} from '../../tr-grid-util/es6/Dom.js';
import {ElfUtil} from '../../tr-grid-util/es6/ElfUtil.js';

declare namespace PercentBarPlugin {

    type Options = {
        padding?: number|null,
        percentageLabel?: boolean|null,
        autoTextSizing?: boolean|null,
        autoFitting?: boolean|null,
        zeroValueHidden?: boolean|null
    };

    type PercentBarOptions = {
        alignment?: string|null,
        field?: string|null,
        textHidden?: boolean|null,
        textWidth?: (number|string)|null,
        useMovementColor?: boolean|null,
        barColor?: string|null,
        padding?: number|null,
        percentageLabel?: boolean|null,
        autoTextSizing?: boolean|null,
        autoFitting?: boolean|null,
        zeroValueHidden?: boolean|null
    };

    type ColumnOptions = {
        percentBar?: (PercentBarPlugin.PercentBarOptions|boolean)|null
    };

}

declare class PercentBarPlugin extends GridPlugin {

    constructor();

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getColumnConfigObject(colIndex: number, out_obj?: any): any;

    public getConfigObject(out_obj?: any): any;

    public setPercentBarAlignment(colIndex: number, alignment: string): void;

    public setColumnPercentBar(colIndex: number, columnOptions: PercentBarPlugin.ColumnOptions|null): void;

    public reloadThemeColors(): Promise<any>|null;

}

export default PercentBarPlugin;
export { PercentBarPlugin, PercentBarPlugin as PercentBar, PercentBarPlugin as PercentBarExtension };
