import { Dom } from "../../tr-grid-util/es6/Dom.js";
import { injectCss, prettifyCss } from "../../tr-grid-util/es6/Util.js";
import { Table } from "../../tr-grid-util/es6/Table.js";

import { PrintTrait } from "./PrintTrait.js";
import { SectionWriter } from "./SectionWriter.js";

declare namespace GridPrinter {

    function setPrintOptions(options: GridPrinter.Options|null): void;

    function observe(iFrameElement?: HTMLIFrameElement|null): void;

    function unobserve(): void;

    function enableDebugMode(bool?: boolean|null): void;

    function getPreFlightInfo(grid: any, options?: any): any;

    function createPrintElement(grid: any, options?: any): Element|null;

    function print(grid: any): void;

    type Options = {
        pageWidth?: number|null,
        pageHeight?: number|null,
        primaryColumn?: number|null
    };

}

export default GridPrinter;
export { GridPrinter };
