import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { ElementWrapper } from "../../tr-grid-util/es6/ElementWrapper.js";
import { Table } from "../../tr-grid-util/es6/Table.js";
import { CellWriter } from "./CellWriter.js";

declare class SectionWriter extends ElementWrapper {

    constructor();

    public getFirstIndexInView(): number;

    public getLastIndexInView(): number;

    public getColumnCount(): number;

    public getColumn(colIndex: number): any;

    public setColumnCount(val: number): void;

    public getRowCount(): number;

    public setRowCount(val: number): void;

    public getCell(colIndex: number, rowIndex: number): CellWriter|null;

    public getCellContent(colIndex: number, rowIndex: number): Element|Node|NodeList|null;

    public setCellContent(colIndex: number, rowIndex: number, data: string|Element|any|any): void;

    public enableRowClass(rowIndex: number, className: string, enabled: boolean): void;

    public stretchCell(cellRef: any, rowIndex?: number|null, stretching?: boolean|null, onlyToTheRight?: boolean|null): any;

    public hasCellSpan(): boolean;

    public getStretchedCell(cellRef: any, rowIndex?: number|null): any;

    public getCellRowSpan(colIndex: number, rowIndex: number): number;

    public setCellRowSpan(colIndex: number, rowIndex: number, rowSpan: number): void;

    public getCellColSpan(colIndex: number, rowIndex: number): number;

    public setCellColSpan(colIndex: number, rowIndex: number, colSpan: number): void;

    public clearCellSpans(): void;

    public clearColumnSpans(colIndex: number): void;

    public isColumnActive(colIndex: number): boolean;

    public getCellElement(colIndex: number, rowIndex: number): Element|null;

}

export default SectionWriter;
export { SectionWriter };
