

declare namespace LEDGuage {

    type RangeValues = {
        low?: number|null,
        last?: number|null,
        high?: number|null,
        close?: number|null,
        vwap?: number|null,
        tick?: number|null
    };

}

declare class LEDGuage {

    constructor();

    public static createElementWithText(text?: string|null): Element|null;

    public setPriceGraph(priceGraph?: boolean|null): void;

    public setRangeValue(rangeBarData: LEDGuage.RangeValues|null): void;

    public isNoRangeValue(): boolean;

    public isHighLowEqual(): boolean;

    public isInvalidRangeValue(): boolean;

    public getEqualRangeElement(): Element|null;

    public getLEDGuageElement(): Element|null;

}

export default LEDGuage;
export { LEDGuage };
