import { Ext } from '../../tr-grid-util/es6/Ext.js';
import { GridPlugin } from '../../tr-grid-util/es6/GridPlugin.js';
import { ElfUtil } from '../../tr-grid-util/es6/ElfUtil.js';
import { injectCss, prettifyCss } from "../../tr-grid-util/es6/Util.js";
import { LEDGuage } from "./LEDGuage.js";

declare namespace RangeBarPlugin {

    type ColumnOptions = {
        rangeBar?: RangeBarPlugin.RangeDefinition|null
    };

    type RangeDefinition = {
        field?: string|null,
        start?: number|null,
        end?: number|null,
        low?: string|null,
        high?: string|null,
        last?: string|null,
        vwap?: string|null,
        close?: string|null,
        tick?: string|null
    };

    type Options = {
        tooltip?: boolean|null
    };

}

declare class RangeBarPlugin extends GridPlugin {

    constructor();

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(out_obj?: any): any;

    public getColumnConfigObject(colIndex: number, out_obj?: any): any;

    public getValue(colRef: number|string|null, rowRef: number|string|null): any;

    public getTooltipText(colRef: number|string|null, rowRef: number|string|null): string;

    public isRangeBarColumn(colIndex: number): boolean;

}

declare function colCount(colIndex: number): boolean;

export default RangeBarPlugin;
export { RangeBarPlugin, RangeBarPlugin as RangeBar, RangeBarPlugin as RangeBarExtension };
