import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { ElfUtil } from "../../tr-grid-util/es6/ElfUtil.js";
import { GridPlugin } from "../../tr-grid-util/es6/GridPlugin.js";
import Dom from "../../tr-grid-util/es6/Dom.js";
import { DragUI } from "../../tr-grid-util/es6/DragUI.js";
import { cloneObject, injectCss, prettifyCss } from "../../tr-grid-util/es6/Util.js";

declare namespace RowDraggingPlugin {

    type Options = {
        dragBox?: boolean|null,
        disabled?: boolean|null,
        mouseInput?: boolean|null,
        dataTransfer?: boolean|null,
        autoScroll?: boolean|null,
        dragBoxRenderer?: ((...params: any[]) => any)|null,
        dragStart?: ((...params: any[]) => any)|null,
        drag?: ((...params: any[]) => any)|null,
        dragEnd?: ((...params: any[]) => any)|null,
        dataMoved?: ((...params: any[]) => any)|null,
        beforeDataMoved?: ((...params: any[]) => any)|null
    };

}

declare class RowDraggingPlugin extends GridPlugin {

    constructor(options?: RowDraggingPlugin.Options|null);

    public hasMultiTableSupport(): boolean;

    public getName(): string;

    public initialize(host: any, options: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(out_obj?: any): any;

    public startDrag(startRef?: any): void;

    public stopDrag(): void;

    public cancelDrag(): void;

    public getGuideline(): Element|null;

    public disable(disabled?: boolean|null): void;

    public isDisabled(): boolean;

    public disableUIs(disabled?: boolean|null): void;

    public allowDrag(allowed?: boolean|null): void;

    public allowDrop(allowed?: boolean|null): void;

    public setDragContent(content: any): void;

    public getDragBox(): Element|null;

    public getDragSource(): string;

    public isDragging(): boolean;

    public disableDragging(disabled?: boolean|null): void;

    public enableJETDragAndDrop(enabled?: boolean|null): void;

    public getJETDragContent(): any;

    public setJETDragContent(content: any): void;

    public moveRows(srcRowIndices: (number)[]|null, destRowIndex: number, srcGrid?: any, destGrid?: any): number;

}

export default RowDraggingPlugin;
export { RowDraggingPlugin, RowDraggingPlugin as RowDragging, RowDraggingPlugin as RowDraggingExtension };
