import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { EventDispatcher } from "../../tr-grid-util/es6/EventDispatcher.js";
import { GridPlugin } from "../../tr-grid-util/es6/GridPlugin.js";
import { isMac as isMacFn, prepareTSVContent, prettifyCss } from "../../tr-grid-util/es6/Util.js";

declare namespace RowSelectionPlugin {

    type Options = {
        singleSelection?: boolean|null,
        selectionChanged?: ((...params: any[]) => any)|null,
        beforeSelection?: ((...params: any[]) => any)|null,
        basedOnContent?: boolean|null,
        selectionField?: string|null,
        menuClicked?: ((...params: any[]) => any)|null,
        menuPosition?: string|null
    };

}

declare class RowSelectionPlugin extends GridPlugin {

    constructor(options?: RowSelectionPlugin.Options|null);

    public getName(): string;

    public hasMultiTableSupport(): boolean;

    public initialize(host: any, options?: any): void;

    public unload(host?: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public clearAllSelections(preserveAnchor?: boolean|null, activeGrid?: any): void;

    public clearSelectedRows(preserveAnchor?: boolean|null, activeGrid?: any): void;

    public clearSelection(preserveAnchor?: boolean|null, activeGrid?: any): void;

    public getActiveGrid(): any;

    public getRowAnchor(sectRef?: any): number;

    public getFirstSelectedIndex(sectRef?: any): number|null|null;

    public getLastSelectedIndex(sectRef?: any): number|null|null;

    public getSelectedRows(sectRef?: any): (number)[]|null;

    public getSelectedRowIds(sectRef?: any): (string)[]|null;

    public getSelectedRowCount(sectRef?: any): number;

    public setSelectedRow(rowIndex: number, opt_select?: boolean|null, sectRef?: any): void;

    public selectSingleRow(rowIndex: number, sectRef?: any, activeGrid?: any): boolean;

    public selectAllRows(activeGrid?: any): void;

    public selectRowRange(rowIndex: number, length: number, sectRef?: any, opt_scrollToRow?: boolean|null): void;

    public disable(disabled?: boolean|null): void;

    public isEnabled(): boolean;

    public disableMultiSelection(disabled?: boolean|null): void;

    public getSelectedText(): string;

}

export default RowSelectionPlugin;
export { RowSelectionPlugin, RowSelectionPlugin as RowSelection, RowSelectionPlugin as RowSelectionExtension };
