import {Ext} from '../../tr-grid-util/es6/Ext.js';
import {GridPlugin} from '../../tr-grid-util/es6/GridPlugin.js';
import {injectCss, prettifyCss} from "../../tr-grid-util/es6/Util.js";

declare namespace RowColoringPlugin {

    type Options = {
        bgColoring?: boolean|null,
        textColoring?: boolean|null,
        bgColorField?: string|null,
        textColorField?: string|null,
        cssField?: string|null,
        cssRangeField?: string|null,
        altCssField?: string|null,
        predefinedColors?: any,
        predefinedColoring?: boolean|null
    };

}

declare class RowColoringPlugin extends GridPlugin {

    constructor(options?: RowColoringPlugin.Options|null);

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public setRowColor(rowRef: string|number|null, bgColor?: (string|null)|null, txtColor?: (string|null)|null): void;

    public getRowColor(rowRef: string|number|null): string;

    public removeRowColor(rowRef: string|number|null): void;

    public toggleRowColor(rowRef: string|number|null, bgColor?: (string|null)|null, txtColor?: (string|null)|null, state?: boolean|null): boolean;

    public setRowPredefinedColor(rowRef: string|number|null, color?: (string|null)|null, range?: (number)[]|null, altColor?: (string|null)|null): void;

    public getPredefinedColors(): any;

    public setPredefinedColors(predefinedColors: any): void;

    public disableTextColoring(opt_bool?: boolean|null): void;

    public disableBgColoring(opt_bool?: boolean|null): void;

    public disableRowColoring(disabled?: boolean|null): void;

    public static getContrastColor(hexColor: string): string;

    public getContrastColor(hexColor: string): string;

    public forceUpdateRowColor(): void;

}

export default RowColoringPlugin;
export { RowColoringPlugin, RowColoringPlugin as RowColoring, RowColoringPlugin as RowColoringExtension };
