import translation from './locale/translation.js';
import ElfUtil from './ElfUtil.js';

declare namespace DateTime {

    function setDateTimePattern(format?: string|null): void;

    function setLocale(lang?: string|null): void;

    function format(dateTimeNumber: number|string|Date|null, dateTimeFormat?: string|null, timezone?: string|null): string;

    function formatDateObject(date: Date|null, dateTimeFormat?: string|null): string;

    function isValidDate(dateObj: Date|null): boolean;

    function isInvalidDate(dateObj: Date|null): boolean;

    function fromDateNumber(dateNumber: number): Date;

    function dateNumberToMs(dateNumber: number): number;

    function timeNumberToMs(dateNumber: number): number;

    function toDateObject(dateInput: string|number|null): any;

    function toDateNumber(dateObj: Date|null): number;

    function toTimeNumber(dateObj: Date|null): number;

    function toYYYYMMDD(dateObj: Date|null): string;

}

declare const INVALID_DATE: Date;

declare const MILLISECONDS_IN_DAY: number;

declare const SECONDS_IN_DAY: number;

declare const SECONDS_IN_HOUR: number;

declare const SECONDS_IN_MINUTE: number;

declare const SHORT_DAYS: (string)[]|null;

declare const FULL_DAYS: (string)[]|null;

declare const SHORT_MONTHS: (string)[]|null;

declare const FULL_MONTHS: (string)[]|null;

declare function prefixZero(num: number): string;

declare function prefixDoubleZero(num: number): string;

export default DateTime;
export { DateTime, MILLISECONDS_IN_DAY, SECONDS_IN_DAY };
