

declare namespace Dom {

    function create(tagName: string, className?: string|null): Element;

    function div(className?: string|null): Element;

    function text(textContent?: (string|number)|null, className?: string|null): Element;

    function appendChild(parentElem: Element|null, children: Node|any[]|null): Element|null;

    function buildTree(parentElem: Element|null, children: Node|any[]|null): Element|null;

    function setContent(elem: Element|null, val: any): void;

    function preventDefault(e: Event|null): void;

    function stopPropagation(e: Event|null): void;

    function getClientPosition(target: Element|Event|MouseEvent, retObj?: any): any;

    function getRelativePosition(A: Element|Event|MouseEvent, B: Element|Event|MouseEvent, retObj?: any): any;

    function closestElement(elem: Element|Node|undefined|null, classStr: string): Element|null;

    function closestTagName(elem: Element|Node|undefined|null, tn: string): Element|null;

}

export default Dom;
export {Dom};
