import { nestedObjectToArray, rgb2Hex } from "./Util.js";
import { Deferred } from "./Deferred.js";
import { ElementObserver } from "./ElementObserver.js";

declare namespace ElfUtil {

    const themeReady: Promise<any>|null;

    const themeColors: { [key: string]:  string }|null;

    function setElfVersion(ver: number): void;

    function getElfVersion(): number;

    function hasComponent(compName: string): number;

    function hasTheme(themeName: string): boolean;

    function getThemeName(optElem?: Element|null): string;

    function isThemeLoaded(): boolean;

    function getColors(): any;

    function isHaloTheme(themeName?: string|null): boolean;

    function isDSTheme(themeName?: string|null): boolean;

    function injectIcons(configObj: any): void;

    function getIconList(): (string)[];

    function prepareIconPreloading(): (string)[]|null;

    function setRTK(rtk: any): void;

    function getMovementColorProfile(): string;

    function reloadThemeColors(): Promise<any>|null;

    function getThemeColors(themeChangedCb?: ((...params: any[]) => any)|null): Promise<any>|null;

}

export default ElfUtil;
export { ElfUtil };
