import { NumberFormatter } from "./NumberFormatter.js"; // eslint-disable-line
import { DateTime } from "./DateTime.js";

declare namespace FieldFormatter {

    type Options = {
        formatType?: string|null,
        type: string,
        field?: string|null,
        fieldDataType?: string|null,
        dateTimeFormat?: string|null,
        useUTCTime?: boolean|null,
        idnSource?: string|null
    };

}

declare class FieldFormatter {

    constructor(options?: FieldFormatter.Options|null);

    public init(options?: FieldFormatter.Options|null): void;

    public getOptions(options?: any): any;

    public getField(): string;

    public clone(): FieldFormatter|null;

    public setFormatType(type: string): void;

    public setField(field: string, combinedField?: string|null, formattedField?: string|null): void;

    public setDateTimeMeta(format: string, gmtTimeZone?: boolean|null, inputSource?: string|null, lang?: string|null): void;

    public setDateFormatter(func: ((...params: any[]) => any)|null): void;

    public setNumberFormatter(formatter: ((...params: any[]) => any)|NumberFormatter|null): void;

    public format(data: any): string;

    public formatRowData(rowData: any): string;

    public formatValue(val: any): string;

}

declare const DATE_TIME: string;

declare function toDateTimeType(formatType: string): string;

declare function fieldDataType(options?: any): any;

export default FieldFormatter;
export {FieldFormatter, DATE_TIME, toDateTimeType};
