

declare namespace FilterOperators {

    type Operator = {
        id: string,
        name: string,
        type: string,
        positive: number,
        caseSensitive: number,
        formula: string
    };

    type Operators = {
        EQ: FilterOperators.Operator,
        NEQ: FilterOperators.Operator,
        NUMEQ: FilterOperators.Operator,
        NUMNEQ: FilterOperators.Operator,
        GT: FilterOperators.Operator,
        GTE: FilterOperators.Operator,
        LT: FilterOperators.Operator,
        LTE: FilterOperators.Operator,
        BEGIN: FilterOperators.Operator,
        NBEGIN: FilterOperators.Operator,
        END: FilterOperators.Operator,
        NEND: FilterOperators.Operator,
        CONT: FilterOperators.Operator,
        NCONT: FilterOperators.Operator,
        EQ_BLANK: FilterOperators.Operator,
        EQ_NBLANK: FilterOperators.Operator,
        DT: FilterOperators.Operator,
        DTA: FilterOperators.Operator,
        DTB: FilterOperators.Operator,
        TXTEQ: FilterOperators.Operator,
        BLANK: FilterOperators.Operator,
        NBLANK: FilterOperators.Operator,
        NEQ_BLANK: FilterOperators.Operator,
        GREATER_THAN: FilterOperators.Operator,
        GREATER_THAN_OR_EQUAL_TO: FilterOperators.Operator,
        EQUAL_TO: FilterOperators.Operator,
        LESS_THAN: FilterOperators.Operator,
        LESS_THAN_OR_EQUAL_TO: FilterOperators.Operator,
        TEXT_THAT_CONTAINS: FilterOperators.Operator,
        TEXT_THAT_NOT_CONTAINS: FilterOperators.Operator,
        TEXT_IS: FilterOperators.Operator,
        NOT_BLANK: FilterOperators.Operator
    };

}

declare const FilterOperators: FilterOperators.Operators;

declare const OperatorFunctions: { [key: string]:  ((...params: any[]) => any) };

export default FilterOperators;
export { FilterOperators, OperatorFunctions };
