import {Ext} from "./Ext.js";
import {EventDispatcher} from "./EventDispatcher.js";
import {Deferred} from "./Deferred.js";
import {injectCss} from "./Util.js";
import {ElfUtil} from "./ElfUtil.js";

declare class GridPlugin extends EventDispatcher {

    constructor();

    public listen(type: string, handler: ((...params: any[]) => any)|null): void;

    public unlisten(type: string, handler: ((...params: any[]) => any)|null): void;

    public afterInit(elem?: Element|null, model?: any, grid?: any): void;

    public hasMultiTableSupport(): boolean;

    public getName(): string;

    public initialize(host: any, gridOptions?: any): void;

    public unload(host?: any): void;

    public getRelativeGrid(e: Event|Element|any): any;

    public setGridWrapper(gridType: string, wrapperInstance: any): void;

    public getGridApi(coreRef?: (number|any)|null): any;

    public getColumnName(colRef: number|string|null): string;

    public getColumnIndex(colRef: number|string|null): number;

    public getColumnIndices(colRefs: (number|string)[]|null): (number)[]|null;

    public getColumnId(colIndex: number|string|null): string;

    public getColumnIds(): (string)[];

    public getColumnField(colIndex: number): string;

    public getColumnFields(): (string)[];

    public getColumnCount(): number;

    public static requestPlugin(ref: any, pluginRef: any, configObj?: any, compositeGrid?: any, realTimeGrid?: any): Promise<any>|null;

    public applyStaticStyles(styleCalculator: ((...params: any[]) => any)|null): void;

    public applyStyles(cssString: string, nameSpace?: string|null, replaceable?: boolean|null): void;

    public revokeStyles(host: any, nameSpace: string): void;

}

declare function gridAPI(gridType: string, wrapperInstance: any): void;

declare function exportExtension(winObj: Window|any|null, plugin: GridPlugin|null): void;

declare function defaultDataGetter(field: string, dvRowData: any): any;

declare function rowDefDataGetter(field: string, dvRowData: any): any;

declare function defaultRowGetter(dvRowData: any): any;

declare function rowDefRowGetter(dvRowData: any): any;

declare function rowGetter(dvRowData: any): any;

declare function colDataGetter(field: string, dt: any): (any)[];

export default GridPlugin;
export {
	GridPlugin,
	exportExtension,

	defaultDataGetter,
	rowDefDataGetter,

	defaultRowGetter,
	rowDefRowGetter,
	rowGetter,

	colDataGetter
};
