import { cloneObject } from "./Util.js";

declare class GroupDefinitions {

    constructor();

    public static getGroupId(groupDef: any): string;

    public static calcTreeDepth(groupMap: { [key: string]:  any }|null, groupDef: any): number;

    public static getLeafDescendants(groupMap: { [key: string]:  any }|null, groupId: string): (string)[]|null;

    public toString(): string;

    public getGroup(groupId: string): any;

    public getDefinition(groupId: string): any;

    public getGroups(): (any)[];

    public getGroupIds(): (string)[];

    public getGroupMap(): { [key: string]:  any };

    public cloneGroupMap(): { [key: string]:  any };

    public rebuildMap(): void;

    public getGroupChildren(groupId: string): (string)[]|null;

    public getLeafDescendants(groupId: string): (string)[]|null;

    public getGroupLevel(groupId: string): number;

    public getRootGroup(groupId: string): any;

    public getParentGroup(childId: string): any;

    public getParentIds(childId: string): (string)[]|null;

    public getParentId(childId: string, groupLevel?: number|null): string;

    public removeAllGroups(): boolean;

    public setGroups(groupDefs?: (any)[]|null): void;

    public addGroup(groupDef: any): string;

    public removeGroup(groupId: string): boolean;

    public setGroup(groupId: string, groupDef?: ((string)[]|any)|null): string;

    public hasGroupChild(parentId: string, childId: string): boolean;

    public contains(groupId: string, childId: string): boolean;

    public addGroupChild(parentId: string, childId: string, position?: number|null): boolean;

    public removeGroupChild(parentId: string, childId?: string|null): boolean;

    public unsetParent(childId: string): boolean;

    public removeAllChildren(groupId: string): boolean;

    public setGroupChildren(groupId: string, newChildList: (string)[]|null): boolean;

    public getGroupName(groupId: string): string;

    public setGroupName(groupId: string, groupName: string): boolean;

}

export default GroupDefinitions;
export { GroupDefinitions };
