import {Ext} from "./Ext.js";
import {EventDispatcher} from "./EventDispatcher.js";
import {TouchProxy} from "./TouchProxy.js";

declare namespace MouseDownTrait {

    type Options = {
        useDragStart?: boolean|null,
        useTouchMove?: boolean|null,
        preventDefault?: boolean|null
    };

}

declare class MouseDownTrait extends EventDispatcher {

    constructor(elem?: Element|null, options?: (string|MouseDownTrait.Options)|null);

    public dispose(): void;

    public disable(opt_bool?: boolean|null): void;

    public enable(opt_bool?: boolean|null): void;

    public getElement(): Element|null;

    public setElement(elem?: Element|null): void;

    public reset(): void;

    public getMouseDown(): any;

    public isMouseDown(): boolean;

    public isMouseUp(): boolean;

    public getDuration(dateObj?: Date|null): number;

}

export {MouseDownTrait};
export default MouseDownTrait;
