import { Ext } from "./Ext.js";
import { EventDispatcher } from "./EventDispatcher.js";
import { cloneObject } from "./Util.js";
import { Deferred } from "./Deferred.js";
import { Dom } from "./Dom.js";

declare class MultiTableManager {

    constructor(gridElem: Element|null);

    public static synchronizeVScrollbar(vScrollbarHost: Element|null, hScrollbarHost: Element|null, gridElems: (Element)[]|null): Promise<any[]>|null;

    public setGridConfig(configObj?: any): void;

    public dispose(): void;

    public getTableCount(): number;

    public setTableCount(num: number): void;

    public wrapTable(rowCount: number): void;

    public getTable(at?: number|null): Element|null;

    public insertRow(rowOption?: any, at?: number|null): void;

    public removeRow(at?: number|null): void;

    public getRowCount(): number;

    public insertColumn(columnOption: any, idx?: number|null): void;

    public removeColumn(colRef: any): void;

    public getColumnCount(): number;

}

export default MultiTableManager;
export { MultiTableManager };
