

declare namespace NumberFormatter {

    type Options = {
        formatType?: string|null,
        type: string,
        precisionEnabled?: boolean|null,
        decimalPlaces?: number|null,
        plusSign?: boolean|null,
        separator?: boolean|null,
        percentSign?: boolean|null,
        scalingUnit?: string|null,
        multiplyBy100?: boolean|null,
        mutiplyBy100?: boolean|null
    };

}

declare class NumberFormatter {

    constructor(options?: NumberFormatter.Options|null);

    public init(options?: NumberFormatter.Options|null): void;

    public resetToDefaults(): void;

    public static padDecimalPartWithZeroes(str: string, precision: number): string;

    public static multiplyByHundred(num: number): number;

    public getOptions(options?: any): any;

    public format(origVal: number): string;

    public enableDefaultFormat(): void;

    public enablePrecision(bool?: boolean|null): void;

    public enableSeparator(bool?: boolean|null): void;

    public enablePercentSign(bool?: boolean|null): void;

    public enablePercentFormat(bool?: boolean|null): void;

    public enablePlusSign(bool?: boolean|null): void;

    public enableMultiplyBy100(bool?: boolean|null): void;

    public enableMillionScaling(bool?: boolean|null): void;

    public enableBillionScaling(bool?: boolean|null): void;

    public isDefaultFormatEnabled(): boolean;

    public isPrecisionEnabled(): boolean;

    public isSeparatorEnabled(): boolean;

    public isPercentSignEnabled(): boolean;

    public isPercentFormatEnabled(): boolean;

    public isPlusSignEnabled(): boolean;

    public isMultiplyBy100Enabled(): boolean;

    public isMillionScalingEnabled(): boolean;

    public isBillionScalingEnabled(): boolean;

    public getPrecision(): number;

    public setPrecision(num: number): void;

    public setSeparatorCharacter(cha: string): void;

    public setPercentSignCharacter(cha: string): void;

}

declare function val(): void;

export default NumberFormatter;
export {NumberFormatter};
