import {Dom} from "./Dom.js";
import { ElfUtil } from "./ElfUtil.js";
import { injectCss, prettifyCss } from "./Util.js";

declare namespace PercentBar {

    type Options = {
        alignment?: string|null,
        movementColor?: boolean|null,
        barColor?: string|null,
        textHidden?: boolean|null,
        textWidth?: (number|string)|null,
        zeroValueHidden?: boolean|null
    };

}

declare class PercentBar {

    constructor(elem?: (Element|null)|null, options?: PercentBar.Options|null);

    public static injectCss(hostElem: Element|null): void;

    public static toAlignment(str: string|null|null): string;

    public getElement(): Element|null;

    public getValue(): number;

    public getPercent(): number;

    public isInvalid(): boolean;

    public setValue(value: number, opt_max?: number|null, displayText?: (string|boolean)|null): void;

    public setMax(absVal: number): void;

    public hideZeroValue(hidden?: boolean|null): boolean;

    public setText(txt: string|number|null): void;

    public hideText(hidden?: boolean|null): boolean;

    public isTextHidden(): boolean;

    public setTextWidth(width: number|string|null): void;

    public setMaxTextLength(width: number|string|null): void;

    public getTextScrollWidth(): number;

    public getAlignment(): string;

    public setAlignment(alignment: string): void;

    public useMovementColor(opt_enabled?: boolean|null): void;

    public setTrackColor(color?: string|null): void;

    public setBarColor(color?: string|null): void;

    public enableTooltip(enabled?: boolean|null): void;

    public updateBarColor(): void;

}

declare function toAlignment(str: string|null|null): string;

export default PercentBar;
export { PercentBar, toAlignment };
