import { injectCss, prettifyCss } from "./Util.js";
import { ExpanderIcon } from "./ExpanderIcon.js";
import { Icon } from "./Icon.js";

declare namespace RowPainter {

    type Options = {
        clickableCell: boolean,
        headerSpanning?: boolean|null,
        footerSpanning?: boolean|null,
        onCellClicked?: ((...params: any[]) => any)|null,
        headerMenuClicked?: ((...params: any[]) => any)|null,
        segmentMode?: boolean|null
    };

    type RenderingOptions = {
        colIndex: number,
        rowIndex: number,
        cell: any,
        section: any,
        footerRow?: boolean|null,
        checkboxColumnIndex: number,
        collapsed?: boolean|null,
        hiddenArrow?: boolean|null,
        groupId?: string|null,
        groupLevel?: number|null,
        nonGroupRow?: boolean|null,
        colorTagClass?: string|null,
        indentSize?: number|null,
        content: any
    };

}

declare class RowPainter {

    constructor(options?: RowPainter.Options|null);

    public static applyGroupingStyles(grid: any): void;

    public static disableColorTag(grid: any, disabled?: boolean|null): void;

    public static enableHeaderMenu(grid: any, enabled?: boolean|null): void;

    public config(options?: RowPainter.Options|null): void;

    public removeHeaderStyle(section: any, columnIndex: number, rowIndex: number): void;

    public removeAllStyles(section: any, columnIndex: number, rowIndex: number): void;

    public applyHeaderStyle(e: RowPainter.RenderingOptions|null): void;

    public applyContentAsHeaderStyle(e: any, collapsed: boolean): void;

    public applyRowStyle(e: any): void;

}

export default RowPainter;
export {RowPainter};
