import { Dom } from "./Dom.js";
import { Ext } from "./Ext.js";
import { ElementWrapper } from "./ElementWrapper.js";

declare class SubTable extends ElementWrapper {

    constructor(opt_elem?: (Element|string)|null);

    public insertRow(at?: number|null): Element|null;

    public addRows(count?: number|null): (Element)[];

    public removeRows(count?: number|null): void;

    public removeAllRows(): void;

    public setRowCount(val: number): void;

    public setDefaultRowHeight(val?: (number|null)|null): void;

    public getColumnCount(): number;

    public getRowCount(): number;

    public getCell(c: number, r: number): Element|null;

    public getCellsInColumn(c: number): (Element)[]|null;

    public getCellsInRow(r: number): (Element)[]|null;

    public getAllCells(): (Element)[];

    public getAllRows(): (Element)[];

    public getRows(): (Element)[];

    public getRow(r: number): Element|null;

    public getTextContents(): (string)[][];

    public getCellTextContent(c: number, r: number): string;

    public getColumnTextContent(c: number): string;

    public getRowTextContent(r: number): string;

    public getTableTextContent(): string;

    public toString(): string;

    public getColumnIndex(e: Event|null): number;

    public getRowIndex(e: Event|null): number;

    public getColumnLeft(colIndex: number, rowIndex?: number|null): number;

    public getRowTop(rowRef: number|Element|null): number;

    public getCellPosition(cell: Element|null, ret_obj?: any): any;

    public setCellRenderer(func: ((...params: any[]) => any)|null): void;

    public getCellRenderer(): ((...params: any[]) => any)|null;

    public cloak(elem: Element|null, opt_elementType?: string|null): void;

    public spanBlock(c1: number, c2: number, r1: number, r2: number): Element|null;

    public static parseTableContent(tbl: Element|null): (string)[][]|null;

}

declare function tdElem(e: Event|null): number;

declare function trElem(colIndex: number, rowIndex?: number|null): number;

export default SubTable;
export { SubTable };
