import {Ext} from "./Ext.js";
import {EventDispatcher} from "./EventDispatcher.js";

declare namespace TouchProxy {

    type Options = {
        useTouchMove?: boolean|null,
        preventDefault?: boolean|null
    };

}

declare class TouchProxy extends EventDispatcher {

    constructor(elem?: Element|null, options?: (boolean|any)|null);

    public static readonly passive: EventListenerOptions;

    public getElement(): Element|null;

    public setElement(elem?: Element|null): void;

    public applyTrait(elem: Element|null): void;

    public dispose(): void;

    public addTouchListeners(touchStartFunc?: ((...params: any[]) => any)|null, touchEndFunc?: ((...params: any[]) => any)|null, touchMoveFunc?: ((...params: any[]) => any)|null): void;

    public removeTouchListeners(): void;

    public attachTouchMoveEvent(): void;

    public detachTouchMoveEvent(): void;

    public attachTouchEvents(touchMove?: boolean|null): void;

    public detachTouchEvents(): void;

    public static getButtonType(e: Event|null): number;

    public static getPosition(e: Event|any|null, obj?: any): any;

}

export {TouchProxy};
export default TouchProxy;
