import { rgb2Hex } from "./Color.js";

declare namespace Util {

    function post(url: string, obj: any|string|null): Promise<Response>;

    function requestText(url: string, obj: any|string|null): Promise<Response>;

    function requestByUrlEncoded(url: string, obj: string): Promise<Response>;

    function toJSON(resp: Response|null): Promise<any>;

    function toText(resp: Response|null): Promise<string>;

}

declare function extendObject(obj: any, extender?: any, limiters?: (string)[]|null): any;

declare function cloneObject(obj: any, limiters?: (string)[]|null): any;

declare function isEmptyObject(obj: any): boolean;

declare function arrayToObject(data?: any[]|null, fields?: (string)[]|null): any|null|null;

declare function extendProperty(obj: any, extender: any, propName: string): void;

declare function deepEqual(obj1: any, obj2: any): boolean;

declare function extendArrayProperty(obj: any, propName: string, ary: any): any[]|null;

declare function prettifyCss(css: string|any[]|null): string;

declare function getShadowRoot(elem: Element|null): DocumentFragment|null;

declare function injectCss(cssStr: string, targetContext?: Element|null): Element|null;

declare function isIE(): boolean;

declare function isMac(): boolean;

declare function isTouchDevice(): boolean;

declare function nestedObjectToArray(obj: any, ary?: any[]|null): any[]|null;

declare function prepareTSVContent(data: any): string;

export default Util;
export {
	Util,
	extendObject,
	cloneObject,
	isEmptyObject,
	deepEqual,
	arrayToObject,
	extendProperty,
	extendArrayProperty,
	prettifyCss,
	getShadowRoot,
	injectCss,
	isIE,
	isMac,
	isTouchDevice,
	nestedObjectToArray,
	rgb2Hex,
	prepareTSVContent
};
