import {AdFinSubscription} from "./AdFinSubscription.js";

/** @namespace */
let AdFinService = {};

/** @type {string}
* @private
*/
AdFinService._uuid = "GUEST";
/** @type {string}
* @private
*/
AdFinService._adfinProductId = "TMON";
/** @type {Object}
* @private
*/
AdFinService._adFinSubscription = null;
/** @type {string|null}
* @private
*/
AdFinService._tracsPlugInUrl = null;

/** @public
* @return {Object}
*/
AdFinService.create = function() {
	let adfinSub = AdFinService._adFinSubscription;
	if (!adfinSub) {
		adfinSub = new AdFinSubscription();
		AdFinService._adFinSubscription = adfinSub;
		AdFinService.setAdFinSettings();
	}
	return adfinSub;
};

/** @public
* @param {(string|null)=} uuid
* @param {(string|null)=} productId
* @param {(string|null)=} adfinUrl
*/
AdFinService.setAdFinSettings = function(uuid, productId, adfinUrl) {
	if(uuid) {
		AdFinService._uuid = uuid;
	}
	if(productId) {
		AdFinService._adfinProductId = productId;
	}
	if(adfinUrl) {
		AdFinService._tracsPlugInUrl = adfinUrl;
	}
	if(AdFinService._adFinSubscription) { // In case set the settings after the service was created.
		uuid = AdFinService._uuid;
		productId = AdFinService._adfinProductId;
		adfinUrl = AdFinService._tracsPlugInUrl;

		AdFinService._adFinSubscription.setAdFinSettings(uuid, productId, adfinUrl);
	}
};

export default AdFinService;
export { AdFinService };
