import Ext from "../Ext.js";
import Formula from "./Formula.js";
import DateTime from "../DateTime.js";
import Info from "./functions/Info.js";
import Logic from "./functions/Logic.js";
import Math from "./functions/Math.js";
import Stat from "./functions/Statistics.js";
import Text from "./functions/Text.js";
import EventDispatcher from "../EventDispatcher.js";

declare class Engine extends EventDispatcher {

    constructor();

    public static getContext(): { [key: string]:  any };

    public static addContext(funcs: { [key: string]:  ((...params: any[]) => any) }|null): void;

    public setFormulaDataGetter(func: ((...params: any[]) => any)|null): void;

    public setFormulaDataSetter(func: ((...params: any[]) => any)|null): void;

    public addFormula(userInput: Formula|string|null): Formula;

    public removeFormula(ref?: Formula|string|number|null): Formula|null;

    public removeAllFormulas(): void;

    public getFormula(opt_ref: string|number|null): Formula|null;

    public getFormulaByExpression(exp: string): Formula|null;

    public getAllFormulas(): (Formula)[]|null;

    public getAllFormulaReferences(): { [key: string]:  string }|null;

    public getFormulaCount(): number;

    public addReference(src: string|Formula|null, ref: string): string;

    public renameReference(oldRef: string, newRef: string): boolean;

    public removeReference(ref: string): boolean;

    public resolveReference(refName: string): string;

    public calculate(rowData: { [key: string]:  any }, opt_changes?: { [key: string]:  any }|null): void;

    public isValidReference(formula: Formula|null, ref: string): boolean;

}

declare function f(): void;

export default Engine;
export { Engine };
