import Ext from "../Ext.js";
import VariableToken from "./VariableToken.js";
import EventDispatcher from "../EventDispatcher.js";

declare class Formula extends EventDispatcher {

    constructor(expression?: string|null, context?: any);

    public static readonly _isBoundFormula: { [key: string]:  boolean }|null;

    public dispose(): void;

    public calculate(rowData: { [key: string]:  any }): any;

    public getFunction(): ((...params: any[]) => any)|null;

    public getFieldNames(): (string)[]|null;

    public getReference(): string;

    public getExpression(): string;

    public toString(): string;

    public getInput(): string;

    public getAlias(): string;

    public setAlias(str: string): void;

    public addFormulaCount(): void;

    public subtractFormulaCount(): boolean;

    public updateContext(): void;

    public static toUpperCase(exp: string): string;

    public static resolveTokens(exp: string, tokens: (VariableToken)[]|null, calcHierarchy: (number)[][]|null): string;

    public addField(field: string, opt_src?: string|null): boolean;

    public changeField(oldName: string, newName: string): boolean;

    public changeFields(oldNames: (string)[]|null, newNames: (string)[]|null): boolean;

    public getRealtimeService(): any;

    public setRealtimeService(rtService: any): void;

    public getIntervalService(funcName: string): any;

    public setIntervalService(funcName: string, newService: any): void;

    public getCachedData(symbol: string): any;

    public setCachedData(symbol: string, values: { [key: string]: any }): void;

    public setDataError(msg: string): void;

    public dispatchDataChanged(e?: any): void;

    public _onDataCacheChanged(e: any): void;

}

export default Formula;
export { Formula };
