/** @constructor */
let MockArchive = function() {
	this._data = {};
};
/** @type {!Object}
*/
MockArchive.prototype._data = null;
/** @public */
MockArchive.prototype.clear = function() {
	this._data = {};
};
/** @public
* @param {string} key
* @param {*} val
*/
MockArchive.prototype.put = function(key, val) {
	if(key) {
		this._data[key] = val;
	}
};
/** @public
* @param {string} key
* @return {*}
*/
MockArchive.prototype.get = function(key) {
	let val = this._data[key];
	return (val != null) ? val : "";
};

/** @public
* @return {Array.<string>} key
*/
MockArchive.prototype.getAllKeys = function() {
	return Object.keys(this._data);
};
/** @public */
MockArchive.prototype.save = function() {
};
/** @public
* @param {Function} func Function that take an item and return boolean
* @return {!Array}
*/
MockArchive.prototype.filter = function(func) {
	let out_ary = [];
	if(func) {
		for(let key in this._data) {
			let val = this._data[key];
			if(func(val)) {
				out_ary.push(val);
			}
		}
	}
	return out_ary;
};

export {MockArchive};
