import {MockQuotes} from "./MockQuotes.js";
import {MockQuotes2} from "./MockQuotes2.js";
import {MockArchive} from "./MockArchive.js";
import {mockDataAPI} from "./mockDataAPI.js";

/** @constructor
* @param {Object=} options
*/
let MockJET = function(options) {
	this["Quotes"] = new MockQuotes();
	this["Quotes2"] = new MockQuotes2();
	this["Archive"] = new MockArchive();
	this["ContainerDescription"] = true;
	this["Data"] = mockDataAPI;
	if(options) {
		this["Quotes2"].config(options);
	}
};

/** @public
* @param {Object=} options
* @return {MockJET}
*/
MockJET.prototype.init = function(options) {
	if(options) {
		this["Quotes2"].config(options);
	}
	return this;
};

/** @public
* @param {Function} handler
* @return {MockJET}
*/
MockJET.prototype.onLoad = function(handler) {
	setTimeout(handler, 2000);
	return this;
};

/** @public
* @param {Object} obj
* @return {MockJET}
*/
MockJET.prototype.navigate = function(obj) {
	return this;
};
/** @public
* @param {string} name
* @param {string} type
* @param {string} property
*/
MockJET.prototype.appHit = function(name, type, property) {
};

/** @public
* @return {Promise}
*/
MockJET.prototype.getUserInfo = function() {
	return Promise.resolve({
		UUID: 'PAXTRA'
	});
};

/** @public
* @param {Array} contextAry
*/
MockJET.prototype.contextChange = function(contextAry) {
};

export default MockJET;
export {MockJET};
