import {DataGenerator} from "./DataGenerator.js";
import {CollectionDict} from "./CollectionDict.js";

declare class MockQuotes2 {

    constructor();

    public config(options?: any): void;

    public create(options?: any): MockSubscriptions|null;

    public isSkipHeaderSupported(): boolean;

    public setUpdateInterval(min?: number|null, max?: number|null): void;

    public setPercentageDataUpdate(percent?: number|null): void;

}

declare class MockSubscriptions {

    constructor(options?: any);

    public create(options?: any): MockSubscriptions|null;

    public config(options?: any): void;

    public setUpdateInterval(min?: number|null, max?: number|null): void;

    public setPercentageDataUpdate(percent?: number|null): void;

    public setPercentageOrderChanged(percent?: number|null): void;

    public setSeed(seed: number): void;

    public addRic(ric: string, subId?: string|null): string|null|null;

    public addChain(ric: string, subId?: string|null): string|null|null;

    public addFields(fields: string|(string)[]|null): void;

    public removeSubscription(subId: string): void;

    public removeRic(): void;

    public removeChain(): void;

    public removeAllSubscriptions(): void;

    public removeFields(fields: string|(string)[]|null): void;

    public removeAllFields(): void;

    public start(): void;

    public stop(): void;

    public dispose(): void;

    public addEventListener(type: string, handler: ((...params: any[]) => any)|null): void;

    public removeEventListener(type: string, handler: ((...params: any[]) => any)|null): void;

    public removeAllEventListeners(): void;

    public getSubscription(subId: string): any;

    public getRic(subId: string): string;

    public getAllFields(): { [key: string]:  boolean }|null;

    public hasField(field: string): boolean;

    public filter(start: number, count: number): MockSubscriptions|null;

    public static simpleDigest(str: string): number;

    public onFeedStatusChanged(feedNames: (string)[]|null, handler: ((...params: any[]) => any)|null): MockSubscriptions|null;

}

export {MockQuotes2, MockSubscriptions};
