import { DataGrid, Adc, setInvalidFields } from "./mockDataAPI.js";
import { MockQuotes2 } from "./MockQuotes2.js";
import { cloneObject } from "../Util.js";

/** @constructor */
let MockRTKData = {};

/** @type {Object}
* @public
*/
MockRTKData.DataGrid = cloneObject(DataGrid);
/** @public
* @param {Object} payload
* @return {*}
*/
MockRTKData.DataGrid.request = function (payload) {
	let p = DataGrid.request(payload);
	return p.then(function (res) {
		return JSON.parse(res);
	});
};

/** @type {Object}
* @public
*/
MockRTKData.Adc = cloneObject(Adc);
/** @public
* @param {Object} payload
* @return {*}
*/
MockRTKData.Adc.request = function (payload) {
	let p = Adc.request(payload);
	return p.then(function (res) {
		return JSON.parse(res);
	});
};

/** @public
* @function
* @param {Object} payload
* @return {*}
*/
MockRTKData.setInvalidFields = setInvalidFields;


/** @constructor */
let MockRTK = {};

/** @type {MockQuotes2}
* @public
*/
MockRTK.Quotes = new MockQuotes2();
/** @type {Object}
* @public
*/
MockRTK.Data = MockRTKData;

/** @public
* @param {Object=} options
* @return {MockRTK}
*/
MockRTK.init = function (options) {
	if(options) {
		MockRTK.Quotes.config(options);
	}

	return new Promise(function (resolve, reject) {
		setTimeout(function(){
			resolve(MockRTK);
		}, 300);
	});
};
/** @public
* @param {Object=} options
* @return {MockRTK}
*/
MockRTK.ready = function (options) {
	return MockRTK.init(options);
};

export default MockRTK;
export { MockRTK };
