/**
* @public
* @type {Object}
*/
let invalidFieldDict = {
	'TR.NonExistField': true,
	'TR.NotExistField': true,
	'CF_IGNORE_FIELD': true
};

/** to mock invalid fields.
* @public
* @param {Array<string>|string} fields ex. TR.NonExistField, CF_IGNORE_FIELD
*/
function setInvalidFields(fields) {
	if (fields && typeof fields === 'string') {
		invalidFieldDict[fields] = true;
	} else if (Array.isArray(fields)) {
		for (let i = 0; i < fields.length; i++) {
			invalidFieldDict[fields[i]] = true;
		}
	}
}

export { invalidFieldDict, setInvalidFields };
