import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { GridPlugin } from "../../tr-grid-util/es6/GridPlugin.js";
import { MouseDownTrait } from "../../tr-grid-util/es6/MouseDownTrait.js";
import { EventDispatcher } from "../../tr-grid-util/es6/EventDispatcher.js";
import { cloneObject, prepareTSVContent } from "../../tr-grid-util/es6/Util.js";
import { ElfUtil } from "../../tr-grid-util/es6/ElfUtil.js";
import { injectCss, prettifyCss } from "../../tr-grid-util/es6/Util.js";

declare namespace CellSelectionPlugin {

    type Options = {
        mode?: string|null,
        multipleSelection?: boolean|null,
        autoDeselecting?: boolean|null,
        tabToSelect?: boolean|null,
        selectionChanged?: ((...params: any[]) => any)|null,
        copy?: ((...params: any[]) => any)|null,
        beforeMouseDown?: ((...params: any[]) => any)|null,
        selectableSections?: any[]|null,
        copyDisabled?: boolean|null
    };

}

declare class CellSelectionPlugin extends GridPlugin {

    constructor(options?: any);

    public hasMultiTableSupport(): boolean;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public getSelectedText(): string;

    public selectAll(): void;

    public deselectAll(): boolean;

    public getSelectionCount(): number;

    public getSelectionBounds(opt_ret?: any): any;

    public getLastSelectionBounds(opt_ret?: any): any;

    public setSelectableSections(types?: (string|(string)[]|null)|null): void;

    public selectSingleCell(anchor: any): void;

    public selectCells(rect: any): void;

    public selectNextCell(): boolean;

    public selectPrevCell(): boolean;

    public getAnchorInfo(): any;

    public getSelectedCells(): (any[])[]|null;

    public disableSelection(opt_disable?: boolean|null): void;

    public setAutoDeselectingOnBlur(bool: boolean): void;

    public getAutoDeselectingOnBlur(): boolean;

}

export default CellSelectionPlugin;
export { CellSelectionPlugin, CellSelectionPlugin as CellSelection, CellSelectionPlugin as CellSelectionExtension };
