import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { preventDefault } from "../../tr-grid-util/es6/EventDispatcher.js";
import { GridPlugin } from "../../tr-grid-util/es6/GridPlugin.js";
import { ElfUtil } from "../../tr-grid-util/es6/ElfUtil.js";
import { cloneObject, deepEqual, injectCss, prettifyCss } from "../../tr-grid-util/es6/Util.js";
import { DragUI } from "../../tr-grid-util/es6/DragUI.js";

declare namespace ColumnDraggingPlugin {

    type Options = {
        dragStart?: ((...params: any[]) => any)|null,
        drag?: ((...params: any[]) => any)|null,
        dragEnd?: ((...params: any[]) => any)|null,
        preColumnMoved?: ((...params: any[]) => any)|null,
        columnMoved?: ((...params: any[]) => any)|null,
        dragInterval?: ((...params: any[]) => any)|null,
        dragBoxRenderer?: ((...params: any[]) => any)|null
    };

}

declare class ColumnDraggingPlugin extends GridPlugin {

    constructor(options?: ColumnDraggingPlugin.Options|null);

    public getName(): string;

    public hasMultiTableSupport(): boolean;

    public initialize(host: any, options?: any): void;

    public unload(host?: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public lockFrozenColumn(lock: boolean): void;

    public disable(disabled?: boolean|null): void;

    public isDisabled(): boolean;

    public disableMoving(disabled?: boolean|null): void;

    public disableDragBox(disabled?: boolean|null): void;

}

export default ColumnDraggingPlugin;
export { ColumnDraggingPlugin, ColumnDraggingPlugin as ColumnDragging, ColumnDraggingPlugin as ColumnDraggingExtension };
