import { Ext } from '../../tr-grid-util/es6/Ext.js';
import { GridPlugin } from '../../tr-grid-util/es6/GridPlugin.js';

declare namespace ColumnFitterPlugin {

    type Options = {
        proportion?: boolean|null,
        constraint?: boolean|null,
        autoAdjust?: (boolean|number)|null,
        autoAdjusting?: (boolean|number)|null,
        title?: boolean|null,
        paddingSize?: number|null,
        shrinkable?: boolean|null
    };

    type ColumnOptions = {
        noFitting?: boolean|null,
        contentFitting?: boolean|null,
        minWidth?: number|null,
        maxWidth?: number|null
    };

}

declare class ColumnFitterPlugin extends GridPlugin {

    constructor(options?: ColumnFitterPlugin.Options|null);

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public getColumnMenu(colIndex: number, config: any): any;

    public adjustColumnWidth(colIndex?: (number)[]|null): boolean;

    public adjustColumns(colIndices?: (number)[]|null, force?: boolean|null): boolean;

    public adjustAllColumns(): boolean;

    public calculateColumnWidth(colIndex: number): number;

    public getAdjustedColumnWidth(colIndex: number): number;

    public resetAllColumns(): void;

}

export default ColumnFitterPlugin;
export { ColumnFitterPlugin, ColumnFitterPlugin as ColumnFitter, ColumnFitterPlugin as ColumnFitterExtension };
