import TextFormatting from './TextFormatting.js';
import {Ext} from '../../tr-grid-util/es6/Ext.js';
import {GridPlugin} from '../../tr-grid-util/es6/GridPlugin.js';
import {ElfUtil} from '../../tr-grid-util/es6/ElfUtil.js';

declare namespace ColumnFormattingPlugin {

    type HeatmapOption = {
        midPoint?: string|null,
        mode?: string|null
    };

    type ConditionalColorOption = {
        conditions?: (any)[]|null,
        field?: string|null
    };

    type BarOption = {
        useMovementColor?: boolean|null,
        showValues?: boolean|null,
        alignment?: string|null,
        field?: string|null,
        textHidden?: boolean|null,
        textWidth?: (number|string)|null,
        barColor?: string|null,
        padding?: number|null,
        percentageLabel?: boolean|null,
        autoTextSizing?: boolean|null,
        autoFitting?: boolean|null,
        zeroValueHidden?: boolean|null
    };

    type DisplayStyleOption = {
        alignment?: string|null,
        mode?: string|null,
        bar?: ColumnFormattingPlugin.BarOption|null,
        conditionalColor?: ColumnFormattingPlugin.ConditionalColorOption|null,
        heatmap?: ColumnFormattingPlugin.HeatmapOption|null,
        general?: any
    };

    type ColumnFormatOptions = {
        valueFormatTab?: TextFormatting.FormatOptions,
        displayStyleTab?: ColumnFormattingPlugin.DisplayStyleOption|null,
        colorTextTab?: any,
        fieldDataType?: string|null
    };

    type ColumnOptions = {
        fieldDataType?: string|null
    };

}

declare class ColumnFormattingPlugin extends GridPlugin {

    constructor();

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public getField(colIndex: number): string;

    public getFieldList(): (string)[]|null;

    public getColumnCount(): number;

    public openDialog(colIndex: number, options?: any): void;

    public getColumnFormatOptions(colIndex: number): ColumnFormattingPlugin.ColumnFormatOptions;

    public setColumnFormatOptions(colIndex: number, options?: ColumnFormattingPlugin.ColumnFormatOptions|null): void;

    public setColumnAlignment(colIndex: number, align: string): void;

    public getColumnAlignment(colIndex: number): string;

    public hasHiddenColumn(): boolean;

    public isColumnHidden(colIndex: number): boolean;

    public hideColumn(colIndex: number, opt_bool?: boolean|null): void;

    public showAllColumns(): void;

    public setFieldDataType(colIndex: number, type: string): void;

}

export default ColumnFormattingPlugin;
export { ColumnFormattingPlugin, ColumnFormattingPlugin as ColumnFormatting, ColumnFormattingPlugin as ColumnFormattingExtension };
