import Ext from "../../../tr-grid-util/es6/Ext.js";
import { isMac } from "../../../tr-grid-util/es6/Util.js";
import { preventDefault } from "../../../tr-grid-util/es6/EventDispatcher.js";

import Plugin from "./Plugin.js";
import { ILayoutGrid, Core } from "../Core/index.js";

declare class ColumnSelectionPlugin extends Plugin {

    constructor(opt_restrictions?: (number|boolean)[]|null, opt_exclusions?: (number|boolean)[]|null);

    public disable(opt_bool?: boolean): void;

    public isEnabled(): boolean;

    public clearSelection(opt_cols?: (number)[]): void;

    public getSelectedColumns(): (number)[];

    public getFirstSelectedColumn(): number;

    public getLastSelectedColumn(): number;

    public setSelectedColumn(colIndex: number, opt_select: boolean, opt_grid?: Core): boolean;

    public selectSingleColumn(opt_colIndex?: number|null, opt_grid?: Core): void;

    public selectRange(anchorIndex: number, len: number, opt_grid?: Core): void;

    public selectAllColumns(): void;

    public isSelectedColumn(colIndex: number): boolean;

    public getActiveGrid(): Core|null;

    public enableSingleSelectionMode(bool?: boolean): void;

}

export default ColumnSelectionPlugin;
export { ColumnSelectionPlugin };
