import Ext from "../../../tr-grid-util/es6/Ext.js";
import { isMac } from "../../../tr-grid-util/es6/Util.js";
import { preventDefault } from "../../../tr-grid-util/es6/EventDispatcher.js";
import Plugin from "./Plugin.js";
import { Core, ILayoutGrid } from "../Core/index.js";

declare class RowSelectionPlugin extends Plugin {

    constructor();

    public clearSelectedRows(opt_preserveAnchor?: boolean, opt_activeGrid?: Core): void;

    public getActiveGrid(): Core|null;

    public setActiveGrid(grid: Core): void;

    public setAnchorSection(): void;

    public getRowAnchor(opt_sectRef?: Core.SectionReference): number;

    public getFirstSelectedIndex(opt_sectRef?: Core.SectionReference): number|null|null;

    public getSelectedRows(opt_sectRef?: Core.SectionReference): (number)[]|null;

    public getSelectedRowCount(opt_sectRef?: Core.SectionReference): number;

    public setSelectedRow(rowIndex: number, opt_select?: boolean, opt_sectRef?: Core.SectionReference): void;

    public selectSingleRow(rowIndex: number, opt_sectRef?: Core.SectionReference, opt_ActiveGrid?: Core): boolean;

    public selectAllRows(opt_ActiveGrid?: Core): void;

    public selectRowRange(rowIndex: number, length: number, opt_sectRef?: Core.SectionReference, opt_scrollToRow?: boolean): void;

    public disableClickToSelect(opt_disable: boolean): void;

    public isEnabled(): boolean;

    public disableMultiSelection(opt_disabled?: boolean, opt_sectRef?: Core.SectionReference): void;

}

export default RowSelectionPlugin;
export { RowSelectionPlugin };
