import {Ext} from '../../tr-grid-util/es6/Ext.js';
import { GridPlugin } from '../../tr-grid-util/es6/GridPlugin.js';

declare namespace ContentWrapPlugin {

    type Options = {
        evenRowHeight?: boolean|null
    };

    type ColumnOptions = {
        contentWrap?: boolean|null
    };

}

declare class ContentWrapPlugin extends GridPlugin {

    constructor();

    public beforeProcessOption(optionName: string): any;

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public adjustRowHeight(sectionRef: any, from?: number|null, to?: number|null): boolean;

    public adjustRowHeightAt(sectionRef: any, rowIndex: number): boolean;

    public enableContentWrapping(colIndex: number, bool?: boolean|null): void;

    public isWrappingContent(colIndex: number): boolean;

}

export default ContentWrapPlugin;
export { ContentWrapPlugin, ContentWrapPlugin as ContentWrap, ContentWrapPlugin as ContentWrapExtension };
