import Ext from "../../../../tr-grid-util/es6/Ext.js";
import EventDispatcher from "../../../../tr-grid-util/es6/EventDispatcher.js";

declare class Segment extends EventDispatcher {

    constructor(rid: string, sharedObj: any);

    public dispose(): void;

    public getId(): string;

    public getParentId(): string;

    public getParent(): Segment|null;

    public getSubSegmentIds(out_ary?: (string)[]|null): (string)[]|null;

    public addChild(rid: string, dataId?: string|null): boolean;

    public addChildren(rids: (string)[]|null, dataIds?: (string)[]|null): boolean;

    public containsChild(rid: string): boolean;

    public getChildIndex(rid: string): number;

    public removeChild(rid: string): boolean;

    public removeChildren(rids: (string)[]|null): boolean;

    public removeAllChildren(): boolean;

    public getChildIds(): (string)[];

    public getChildren(): any;

    public getChildCount(): number;

    public markCollapsingStateDirty(): void;

    public getClassification(): (string)[]|null;

    public setClassification(fields: string|(string)[]|null): boolean;

    public classify(rows?: { [key: string]:  any }|null): boolean;

    public hasSubSegments(): boolean;

    public isSubSegment(): boolean;

    public isRootSegment(): boolean;

    public getFirstAncestor(): Segment|null;

    public getAllSubSegments(out_ary?: (Segment)[]|null): (Segment)[]|null;

    public updateTreeStructure(counter: number, rootOrder: number, ridMap: any): number;

    public getSegmentLevel(): number;

    public setRowData(rows?: any, clsSource?: any): void;

    public getSubSegmentName(row?: any): string;

    public sortSegments(comparer: ((...params: any[]) => any)): boolean;

    public getFlattenTreeIds(ary: (string)[]|null): (string)[];

    public collapse(bool?: boolean|null): boolean;

    public expand(bool?: boolean|null): boolean;

    public isCollapsed(): boolean;

    public getCollapsingStates(objMap?: any, parentState?: boolean|null): boolean;

    public getOrder(): number;

    public getLastOrder(): number;

    public setOrder(val: number): void;

    public setLastOrder(val: number): number;

    public log(lines?: (string)[]|null, tabLevel?: number|null): (string)[];

}

declare const UNCATEGORY: string;

export default Segment;
export { Segment, UNCATEGORY };
