import Ext from "../../../../tr-grid-util/es6/Ext.js";
import EventDispatcher from "../../../../tr-grid-util/es6/EventDispatcher.js";
import { Segment, UNCATEGORY } from "./Segment.js";

declare class SegmentCollection extends EventDispatcher {

    constructor();

    public dispose(): void;

    public addSegment(rid: string, childRids?: (string)[]|null): boolean;

    public addSegments(rids: (string)[]|null): boolean;

    public containsSegment(rid: string): boolean;

    public getParentRowId(rid: string): string;

    public removeSegment(rid: string): boolean;

    public removeAllSegments(): boolean;

    public getSegmentCount(): number;

    public getSegment(rid: string): Segment|null;

    public getSegmentParent(rid: string): Segment|null;

    public getSegments(): { [key: string]:  Segment }|null;

    public getSegmentIds(): (string)[];

    public sortSegments(comparer: ((...params: any[]) => any)): (Segment)[];

    public collapseSegments(segmentIds: (string)[]|null, bool?: boolean|null): boolean;

    public collapseSegment(segmentId: string, bool?: boolean|null): boolean;

    public expandSegment(segmentId: string, bool?: boolean|null): boolean;

    public expandAllSegments(): boolean;

    public isCollapsedSegment(segmentId: string): boolean;

    public getCollapsedRows(): any;

    public invalidateSegmentOrder(): boolean;

    public addSegmentChild(segmentId: string, rid: string, dataId?: string|null): boolean;

    public addSegmentChildren(segmentId: string, rids: (string)[]|null, dataIds?: (string)[]|null): boolean;

    public containsSegmentChild(segmentId: string, rid: string): boolean;

    public removeSegmentChild(segmentId: string, rid: string): boolean;

    public removeSegmentChildren(segmentId: string, rids: (string)[]|null): boolean;

    public removeAllSegmentChildren(): boolean;

    public fillSegment(segmentId: string, rids: (string)[]|null): void;

    public fillSegments(rids: (string)[]|null): boolean;

    public calcSegmentOrder(rids: (string)[]|null, useCache?: boolean|null): void;

    public getSegmentValues(rids: (string)[], partial?: boolean|null): (number)[]|null;

    public logStructure(): string;

    public logRowIdMap(): string;

    public setSegmentClassification(segmentId: string, fields: string|(string)[]|null): boolean;

    public hasClassification(): boolean;

    public classify(rows: { [key: string]:  any }|null): boolean;

    public setDefaultCollapsing(bool: boolean): boolean;

}

export default SegmentCollection;
export { SegmentCollection };
