import Ext from "../../../../tr-grid-util/es6/Ext.js";
import Util from "./util/util.js";
import Cell from "./components/Cell.js";
import Column from "./components/Column.js";
import VirtualItems from "./components/VirtualItems.js";
import StretchedCells from "./components/StretchedCells.js";
import CellSpans from "./components/CellSpans.js";
import CellSpan from "./components/CellSpan.js";
import TrackLayout from "./util/TrackLayout.js";
import SelectionList from "./util/SelectionList.js";
import ILayoutGrid from "./ILayoutGrid.js";
import ElementWrapper from "./components/ElementWrapper.js";
import HScrollbar from "./components/HScrollbar.js";
import CellBoundPainter from "./util/CellBoundPainter.js";

declare class LayoutGrid extends ElementWrapper {

    constructor(options?: any);

    public getContextRow(rowIndex: number): any;

    public selectColumn(colIndex: number, selected?: boolean|null): void;

    public isSelectedColumn(colIndex: number): boolean;

    public selectCell(colIndex: number, rowIndex: number, selected?: boolean|null): void;

    public setCellBounds(colIndex: number, rowIndex: number, width: number, height: number): void;

    public updateColumnSeparators(): void;

}

declare function rgtPx(): void;

export default LayoutGrid;
export { LayoutGrid };
