import Util from "../util/util.js";

declare class TrackLayout {

    constructor();

    public hitTest(val: number): number;

    public dispose(): void;

    public isAtDefaultSize(opt_index?: number|null): boolean;

    public isHomogeneous(): boolean;

    public isAtMinimumSize(opt_index?: number|null): boolean;

    public isFixedSize(): boolean;

    public clearLaneCustomizations(): void;

    public getLaneCount(): number;

    public setLaneCount(val: number): void;

    public getDefaultLaneSize(): number;

    public setDefaultLaneSize(val: number): boolean;

    public getLaneDefaultSize(index: number): number;

    public setLaneDefaultSize(index: number, val: number): void;

    public resetLaneToDefaultSize(): boolean;

    public getDefaultScalability(): boolean;

    public setDefaultScalability(val: boolean): boolean;

    public getTrackSize(): number;

    public setTrackSize(targetSize: number): (number)[]|null|null;

    public getLaneStart(index: number): number;

    public getLaneEnd(index: number): number;

    public getLaneSize(index: number): number;

    public getCustomLaneSize(index: number): number;

    public setLaneSize(index: number, val: number): boolean;

    public setLaneProperty(index: number, propName: string, val: any): boolean;

    public getLaneProperty(index: number, propName: string): any;

    public getMinimumLaneSize(index: number): number;

    public setMinimumLaneSize(index: number, val: number, proportion?: boolean|null): boolean;

    public isLaneVisible(index: number): boolean;

    public showLane(index: number, opt_val?: boolean|null): boolean;

    public hideLane(index: number, hidden?: boolean|null, bitIndex?: number|null): boolean;

    public getLaneVisibilityBit(index: number, bitIndex?: number|null): boolean;

    public show(opt_shown?: boolean|null): void;

    public getLaneScalability(index: number): boolean;

    public setLaneScalability(index: number, val: boolean): boolean;

    public removeLaneAt(index: number, opt_count?: number|null): any|null|null;

    public insertLane(index: number, opt_json?: number|any|null): void;

    public moveLane(from: number, to: number): void;

    public serializeLane(index: number): any|null|null;

    public deserializeLane(index: number, opt_json?: any): void;

    public copyFrom(src: TrackLayout|null, offset?: number|null): void;

}

declare function toIndex(from: number, to: number): void;

export default TrackLayout;
export { TrackLayout };
