import {Ext} from '../../tr-grid-util/es6/Ext.js';
import {GridPlugin} from '../../tr-grid-util/es6/GridPlugin.js';
import {ElfUtil} from '../../tr-grid-util/es6/ElfUtil.js';
import {ElfDate} from '../../tr-grid-util/es6/ElfDate.js';
import { CoralItems } from '../../tr-grid-util/es6/CoralItems.js';

declare namespace FilterInputPlugin {

    type GridColumn = {
        filterInput?: FilterInputPlugin.ColumnOptions|null
    };

    type ColumnOptions = {
        defaultLogic?: ((...params: any[]) => any)|null,
        filterLogic?: ((...params: any[]) => any)|null,
        disabled?: boolean|null,
        placeholder?: string|null,
        type?: string|null,
        entries?: any[]|null,
        defaultValue?: any,
        trigger?: string|null
    };

    type Options = {
        inputCreated?: ((...params: any[]) => any)|null,
        trigger?: string|null
    };

}

declare class FilterInputPlugin extends GridPlugin {

    constructor(options?: FilterInputPlugin.Options|null);

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(out_obj?: any): any;

    public getColumnInput(colIndex: number): Element|null;

    public removeColumnFilters(colIndex?: (null|number)|null): void;

    public removeColumnFilter(colIndex?: (null|number)|null): void;

    public setInputValue(colIndex: number, value: any): void;

    public disableColumnInput(colIndex: number, disabled?: boolean|null): void;

    public refresh(delayMs?: number|null): void;

    public setFilterLogic(colIndex: number, func: ((...params: any[]) => any)|null, ctx?: any): void;

    public filterColumn(colIndex: number, text: string, textMap?: any): void;

}

export default FilterInputPlugin;
export { FilterInputPlugin, FilterInputPlugin as FilterInput, FilterInputPlugin as FilterInputExtension };
