import {Ext} from '../../tr-grid-util/es6/Ext.js';
import {GridPlugin, colDataGetter} from '../../tr-grid-util/es6/GridPlugin.js';
import {CellPainter} from '../../tr-grid-util/es6/CellPainter.js';
import {ElfUtil} from '../../tr-grid-util/es6/ElfUtil.js';

declare namespace HeatMapPlugin {

    type ColumnOptions = {
        field: string,
        heatMap?: HeatMapPlugin.HeatMap|null
    };

    type HeatMap = {
        midPoint?: number|null,
        mode?: string|null
    };

}

declare class HeatMapPlugin extends GridPlugin {

    constructor();

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any, opt_grid?: any): void;

    public getConfigObject(out_obj?: any): any;

    public getColumnHeatMap(colIndex: number, grid?: any): CellPainter|null;

    public setColumnHeatMap(colIndex: number, columnDef: any, opt_grid?: any): void;

    public getColumnHeatMapOptions(colIndex: number, options?: any): any;

}

declare function cond(colIndex: number, options?: any): any;

export default HeatMapPlugin;
export { HeatMapPlugin, HeatMapPlugin as HeatMap, HeatMapPlugin as HeatMapExtension };
