import Grid from "./Grid.js";
import RowDefinition from "./RowDefinition.js";
import { Deferred } from "../../../tr-grid-util/es6/Deferred.js";

declare namespace FieldDefinition {

    function set(field: string, def: any): void;

    function resetAll(): void;

    function get(field: string): any;

    function getFieldInfo(field: string): any;

    function hasFieldInfo(field: string): boolean;

    function getTimeSeriesChildren(field: string): any[]|null;

    function addTimeSeriesChild(tsDef: string, childDef: any): void;

    function remove(field: string): void;

    function setSynapseConfig(config: Grid.SynapseConfig|null): void;

    function disableTimeSeriesExpansion(disabled: boolean): void;

    function isFormula(field: string): boolean;

    function isAdc(field: string): boolean;

    function isRealTimeField(field: string): boolean;

    function isTimeSeriesChild(field: string): boolean;

    function isTimeSeries(field: string): boolean;

}

export {FieldDefinition};
export default FieldDefinition;
