import { Ext } from "../../tr-grid-util/es6/Ext.js";
import { GridPlugin, rowDefRowGetter } from "../../tr-grid-util/es6/GridPlugin.js";
import { ExpanderIcon } from "../../tr-grid-util/es6/ExpanderIcon.js";
import { ElfUtil } from "../../tr-grid-util/es6/ElfUtil.js";
import { RowPainter } from "../../tr-grid-util/es6/RowPainter.js";
import { injectCss, prettifyCss } from "../../tr-grid-util/es6/Util.js";
import { Conflator } from "../../tr-grid-util/es6/Conflator.js";

declare namespace RowSegmentingPlugin {

    type SortingLogic = (rowDataA: any, rowDataB: any) => number;

    type Options = {
        spanning?: boolean|null,
        colorTag?: boolean|null,
        cssField?: string|null,
        predefinedColors?: any,
        clicked?: ((...params: any[]) => any)|null,
        headerMenuClicked?: ((...params: any[]) => any)|null,
        segmentSeparatorBinding?: ((...params: any[]) => any)|null,
        nonSegmentSeparatorBinding?: ((...params: any[]) => any)|null,
        sortingLogic?: ((...params: any[]) => any)|null,
        rowSpanningField?: string|null,
        segmentIdField?: string|null,
        displayColumn?: (string|number)|null
    };

}

declare class RowSegmentingPlugin extends GridPlugin {

    constructor(options?: RowSegmentingPlugin.Options|null);

    public getName(): string;

    public initialize(host: any, options?: any): void;

    public requestSeparatorRefresh(): void;

    public unload(host?: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public getRowConfigObject(rowData: any, rowId: string): any;

    public updateHeaders(): void;

    public getSegmentParentRowId(rowRef: string|number|null): string;

    public _resolveDisplayColumn(): number;

    public setSegmentSeparators(rowIds: (string)[]|null, enabled?: boolean|null): boolean;

    public setSegmentSeparator(rowRef: string|number|null, enabled?: boolean|null): boolean;

    public setSegmentClassification(rowRef: string|number|null, fields: string|(string)[]|null): boolean;

    public unsetAllSegmentSeparators(): boolean;

    public hasSegmentation(): boolean;

    public isSegmentSeparator(rowRef: string|number|null): boolean;

    public collapseSegments(rowIds: (string )[]|null, collapsed: (string )[]|null): boolean;

    public collapseSegment(rowRef: string|number|null, collapsed?: boolean|null): boolean;

    public expandSegment(rowRef: string|number|null, expanded?: boolean|null): boolean;

    public expandAllSegments(): boolean;

    public isSegmentCollapsed(rowRef: string|number|null): boolean;

    public setSegmentCollapsingLogic(func: ((...params: any[]) => any)|null): void;

    public fillSegment(segmentRef: string|number|null): void;

    public fillSegments(): void;

    public addSegmentChild(segmentRef: string|number|null, rowRef: string|number|null): void;

    public setSegmentChildren(segmentArr: (any)[]|null): void;

    public addSegmentChildren(segmentRef: string|number|null, rowRefs: (string|number)[]|null): void;

    public removeSegmentChild(segmentRef: string|number|null, rowRef: string|number|null): void;

    public removeSegmentChildren(segmentRef: string|number|null, rowRefs: (string|number)[]|null): void;

    public removeAllSegmentChildren(): void;

    public getSegmentIds(): (string)[]|null;

    public getSegmentChildIds(segmentRef: string|number|null): (string)[]|null;

    public setSortingLogic(sortFunction: RowSegmentingPlugin.SortingLogic|null): void;

    public sortSegments(sortFunction?: RowSegmentingPlugin.SortingLogic|null): void;

    public setPredefinedColors(predefinedColors: any): void;

    public spanSegmentSeparator(rowRef: number|string|null, spanning: boolean|null|null): void;

}

export default RowSegmentingPlugin;
export { RowSegmentingPlugin, RowSegmentingPlugin as RowSegmenting, RowSegmentingPlugin as RowSegmentingExtension };
