import {Ext} from '../../tr-grid-util/es6/Ext.js';
import {GridPlugin} from '../../tr-grid-util/es6/GridPlugin.js';
import {NumberFormatter} from '../../tr-grid-util/es6/NumberFormatter.js';
import { FieldFormatter } from '../../tr-grid-util/es6/FieldFormatter.js';
import { DateTime } from '../../tr-grid-util/es6/DateTime.js';

declare namespace TextFormattingPlugin {

    type FormatOptions = {
        formatType?: string|null,
        field?: string|null,
        decimalPlaces?: (number|boolean)|null,
        precisionEnabled?: boolean|null,
        plusSign?: boolean|null,
        separator?: boolean|null,
        percentSign?: boolean|null,
        scalingUnit?: string|null,
        multiplyBy100?: boolean|null,
        dateTimeFormat?: string|null,
        useUTCTime?: boolean|null,
        autoTextFormatting?: boolean|null,
        formatLogic?: ((...params: any[]) => any)|null
    };

    type ColumnOptions = TextFormattingPlugin.FormatOptions|null;

    type GridOptions = {
        autoTextFormatting?: boolean|null
    };

    type FormatLogicArguments = {
        colIndex: number,
        rowIndex: number,
        field: string,
        formattedText: string,
        cell: any,
        rowData: any,
        format: ((...params: any[]) => any)|null
    };

}

declare class TextFormattingPlugin extends GridPlugin {

    constructor();

    public getName(): string;

    public hasMultiTableSupport(): boolean;

    public initialize(host: any, options?: any): void;

    public unload(host: any): void;

    public config(options?: any): void;

    public getConfigObject(gridOptions?: any): any;

    public setColumnFormat(colIndex: number, formatOptions: TextFormattingPlugin.FormatOptions|null): void;

    public getColumnFormatOptions(colIndex: number, options?: any): any;

    public getFormatter(colIndex: number): FieldFormatter|null;

    public formatText(colIndex: number, obj: any): string;

    public openDialog(colIndex: number): void;

}

export default TextFormattingPlugin;
export { TextFormattingPlugin, TextFormattingPlugin as TextFormatting, TextFormattingPlugin as TextFormattingExtension };
