import { GridPlugin } from "../../tr-grid-util/es6/GridPlugin.js";
import Ext from "../../tr-grid-util/es6/Ext.js";

declare namespace ZoomPlugin {

    type Options = {
        zoomFactor?: number|null,
        step?: number|null,
        wheel?: boolean|null,
        maxFactor?: number|null,
        minFactor?: number|null,
        zoomChanged?: ((...params: any[]) => any)|null
    };

}

declare class ZoomPlugin extends GridPlugin {

    constructor(options?: ZoomPlugin.Options|null);

    public hasMultiTableSupport(): boolean;

    public config(options?: ZoomPlugin.Options|null): void;

    public getConfigObject(gridOptions?: any): any;

    public getZoomFactor(): number;

    public zoomIn(): number;

    public zoomOut(): number;

    public zoomTo(factor?: number|null): number;

    public setStep(step: number): void;

    public zoomDefault(zoomFactor?: number|null): number;

    public addElement(elem: Element|null): void;

    public removeElement(elem: Element|null): Element|null;

    public updateZoomedLayout(): void;

    public enableWheelToZoom(bool?: boolean|null): void;

    public getDefaultMouseWheelLogic(): ((...params: any[]) => any)|null;

}

export default ZoomPlugin;
export { ZoomPlugin, ZoomPlugin as Zoom, ZoomPlugin as ZoomExtension };
